/*     */ package com.netapp.asup.client.helper;
/*     */ 
/*     */ import java.util.ArrayList;
/*     */ import java.util.Arrays;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class RestXmlConstants
/*     */ {
/*     */   public static final String XML_TAG = "xml";
/*     */   public static final String SUCCESS = "SUCCESS";
/*     */   public static final String RESULTS_TAG = "results";
/*     */   public static final String RESULT_TAG = "result";
/*     */   public static final String SYSTEM_TAG = "system";
/*     */   public static final String ASUPS_TAG = "asups";
/*     */   public static final String ASUP_TAG = "asup";
/*     */   public static final String CONTENT_TAG = "content";
/*     */   public static final String LINK_TAG = "link";
/*     */   public static final String STATUS_TAG = "status";
/*     */   public static final String REQUEST_ID_TAG = "request_id";
/*     */   public static final String RESPONSE_TIME_TAG = "response_time";
/*     */   public static final String CLIENT_ID_TAG = "client_id";
/*     */   public static final String STATUS_CODE_TAG = "status_code";
/*     */   public static final String LIST_TAG = "list";
/*     */   public static final String RESULT_COUNT_TAG = "results_count";
/*     */   public static final String TOTAL_RESULT_COUNT_TAG = "total_results_count";
/*     */   public static final String START_TAG = "start";
/*     */   public static final String LIMIT_TAG = "limit";
/*     */   public static final String OBJECT_TAG = "object";
/*     */   public static final String NAME_TAG = "name";
/*     */   public static final String OBJECT_VIEW_TAG = "object_view";
/*     */   public static final String FSLASH = "/";
/*  59 */   public static final String[] ASUP_RESPONSE_TAGS = { "asup_id", "asup_subject", "asup_type", "asup_gen_date", "asup_received_date", "asup_gen_zone" };
/*     */   
/*  61 */   public static final String[] SYSTEM_RESPONSE_TAGS = { "system_id", "sys_serial_no", "sys_model", "sys_type", "hostname", "sys_version" };
/*     */   
/*  63 */   public static final String[] ALL_ASUP_SYSTEM_RESPONSE_TAGS = { "system_id", "sys_serial_no", "sys_model", "sys_type", "hostname", "sys_version", "sys_top_domain", "sys_domain" };
/*     */   
/*  65 */   public static final String[] ALL_ASUP_RESPONSE_TAGS = { "biz_key", "asup_id", "asup_subject", "asup_type", "asup_gen_date", "asup_received_date", "asup_gen_zone", "asup_is_minimal", "sys_version", "sys_operating_mode" };
/*     */   
/*     */   public static final String HA_GROUP_TAG = "ha_group";
/*     */   
/*  69 */   public static final String[] SYSTEM_HA_RESPONSE_TAGS = { "partner_system_id", "partner_hostname", "partner_sys_serial_no" };
/*     */   
/*  71 */   public static final String[] STATUS_RESPONSE_TAGS = { "asup_id", "system_id", "sys_serial_no", "sequence_number", "asup_subject", "asup_gen_date", "hostname", "status_code", "last_step", "last_step_time_stamp", "error_reason", "message" };
/*     */   
/*  73 */   public static final ArrayList<String> BASE64_EXTENSIONS_LIST = new ArrayList(Arrays.asList(new String[] { ".GZ", ".TGZ", ".ZIP", ".TAR.GZ", ".TAR", ".LOG.GZ" }));
/*  74 */   public static final ArrayList<String> TEXT_EXTENSIONS_LIST = new ArrayList(Arrays.asList(new String[] { ".LOG", ".XML", ".CONF", ".DAT", ".DUMP", ".FLAG", ".TXT" }));
/*     */   
/*     */ 
/*     */   public static final String PARENTS = "parents";
/*     */   
/*     */ 
/*     */   public static final String PARENT = "parent";
/*     */   
/*     */   public static final String CHILDS = "childs";
/*     */   
/*     */   public static final String CHILD = "child";
/*     */   
/*     */   public static final String ROWS = "rows";
/*     */   
/*     */   public static final String ROW = "row";
/*     */   
/*     */   public static final String ERROR_CODE_TAG = "error_code";
/*     */   
/*     */   public static final String MESSAGE_TAG = "message";
/*     */   
/*     */   public static final String FAILURE = "FAILURE";
/*     */   
/*     */   public static final String ASUP_REST_URL = "asup_rest_url";
/*     */   
/*     */   public static final String ERROR = "Error";
/*     */   
/*     */   public static final String QUERY = "query";
/*     */   
/*     */   public static final String TYPE_ATTRIBUTE = "type";
/*     */   
/*     */   public static final String OPTIONS = "options";
/*     */   
/*     */   public static final String VALUE = "value";
/*     */   
/*     */   public static final String RESULTS_COUNT = "results_count";
/*     */   
/*     */   public static final String DATA = "data";
/*     */   
/*     */   public static final String DATALINK = "datalink";
/*     */   
/*     */   public static final String ENCODING = "UTF-8";
/*     */   
/*     */   public static final String INFO_ATTR = "info";
/*     */   
/* 118 */   public static final String[] STATUS_SOLR_RESPONSE_TAGS = { "asup_id", "sequence_number" };
/*     */   
/* 120 */   public static final String[] STATUS_HBASE_RESPONSE_TAGS = { "status", "last_step", "last_step_time_stamp", "message" };
/*     */   
/* 122 */   public static final String[] STATUS_SUCCESS_CODES = { "SUCCESS", "ERROR" };
/*     */   
/* 124 */   public static final String[] STATUS_FAILURE_CODES = { "FAILURE", "FAILED", "INITIALIZED", "TIMEOUT", "PARTIAL" };
/*     */   
/*     */   public static final String STATUS_ERROR_REASON = "message";
/*     */   
/*     */   public static final String STATUS_STATUS_CODE = "status_code";
/*     */   
/*     */   public static final String ERROR_REASON_TAG = "error_reason";
/*     */   
/* 132 */   public static final String[] CLUSTER_TAGS = { "cluster_name", "cluster_identifier", "cluster_member_identifier" };
/*     */   public static final String CLUSTER_TAG = "cluster";
/*     */   public static final String CLUSTER_NODES_SUMMARY = "cluster_nodes_summary";
/*     */   public static final String ASUP_SUMMARY = "asup_summary";
/*     */   public static final String ASUP_CONTENT_LIST = "asup_content_list";
/*     */   public static final String ASUP_OBJECT_LIST = "asup_object_list";
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\client\helper\RestXmlConstants.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */