/*     */ package com.netapp.asupdata.client.ARMA;
/*     */ 
/*     */ import com.netapp.asup.client.arma.ARMAFilter;
/*     */ import com.netapp.asup.common.AsupLogger;
/*     */ import com.netapp.asup.data.objects.Filter;
/*     */ import com.netapp.asup.exception.ARMAException;
/*     */ import com.netapp.asup.exception.ARMAIllegalArgumentException;
/*     */ import com.netapp.asup.util.StringUtils;
/*     */ import java.util.Collections;
/*     */ import java.util.Map;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ARMAFilterImpl
/*     */   implements ARMAFilter
/*     */ {
/*  29 */   private static final AsupLogger LOG = AsupLogger.getLogger(ARMAFilterImpl.class);
/*     */   
/*     */ 
/*  32 */   private ObjectFilter filter = new ObjectFilter();
/*     */   
/*  34 */   private ARMAObjectImpl armaObjectImpl = null;
/*     */   
/*     */   public ARMAFilterImpl(ARMAObjectImpl armaObjectImpl) {
/*  37 */     this.armaObjectImpl = armaObjectImpl;
/*     */   }
/*     */   
/*     */   public void setFilter(String attributeName, String attributeValue)
/*     */     throws ARMAException
/*     */   {
/*  43 */     validateAttributeName(attributeName);
/*  44 */     validateAttributeValue(attributeValue);
/*     */     
/*  46 */     this.filter.set(attributeName, attributeValue);
/*  47 */     resetCache();
/*     */   }
/*     */   
/*     */   private void resetCache() {
/*  51 */     this.armaObjectImpl.getSession().clearSessionData();
/*     */   }
/*     */   
/*     */   public void setMultiValueFilter(String attributeName, String... attributeValues)
/*     */     throws ARMAException
/*     */   {
/*  57 */     validateAttributeName(attributeName);
/*     */     
/*  59 */     validateAttributeValues(attributeValues);
/*  60 */     StringBuilder s = new StringBuilder(attributeValues[0]);
/*     */     
/*  62 */     for (int i = 1; i < attributeValues.length; i++) {
/*  63 */       s.append('\037');
/*  64 */       s.append(attributeValues[i]);
/*     */     }
/*     */     
/*  67 */     this.filter.set(attributeName, s.toString());
/*  68 */     resetCache();
/*     */   }
/*     */   
/*     */ 
/*     */   private void validateAttributeValues(String[] attributeValues)
/*     */     throws ARMAIllegalArgumentException
/*     */   {
/*  75 */     for (String attributeValue : attributeValues) {
/*  76 */       validateAttributeValue(attributeValue);
/*     */     }
/*     */   }
/*     */   
/*     */   public boolean removeFilter(String attributeName) throws ARMAException
/*     */   {
/*  82 */     validateAttributeName(attributeName);
/*  83 */     boolean isRemoved = this.filter.remove(attributeName);
/*  84 */     resetCache();
/*     */     
/*  86 */     return isRemoved;
/*     */   }
/*     */   
/*     */   public boolean removeAllFilterForObject()
/*     */   {
/*  91 */     boolean isRemoved = this.filter.removeAll();
/*  92 */     resetCache();
/*  93 */     return isRemoved;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean removeAllFilterForPath()
/*     */   {
/* 102 */     resetCache();
/* 103 */     return this.armaObjectImpl.getSession().removeAllFilterForPath();
/*     */   }
/*     */   
/*     */   public Map<String, String> getFilters() {
/* 107 */     return this.filter.getAllFilters();
/*     */   }
/*     */   
/*     */   public Map<String, String> getAllFilterForObject()
/*     */   {
/* 112 */     return getFilters();
/*     */   }
/*     */   
/*     */   public Map<String, Map<String, String>> getAllFilterForPath()
/*     */   {
/* 117 */     return Collections.unmodifiableMap(this.armaObjectImpl.getSession().getFilter().getAllFilters());
/*     */   }
/*     */   
/*     */   private void validateAttributeValue(String attributeValue) throws ARMAIllegalArgumentException
/*     */   {
/* 122 */     if (null == attributeValue) {
/* 123 */       String message = "Attribute value cannot be null:{" + attributeValue + '}';
/*     */       
/* 125 */       throw new ARMAIllegalArgumentException(LOG, this.armaObjectImpl.getRequestId(), message);
/*     */     }
/*     */   }
/*     */   
/*     */   private void validateAttributeName(String attributeName)
/*     */     throws ARMAIllegalArgumentException
/*     */   {
/* 132 */     if (StringUtils.isEmpty(attributeName)) {
/* 133 */       String message = "Invalid attribute name is provided:{" + attributeName + '}';
/*     */       
/* 135 */       throw new ARMAIllegalArgumentException(LOG, this.armaObjectImpl.getRequestId(), message);
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asupdata\client\ARMA\ARMAFilterImpl.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */