/*     */ package com.sun.xml.bind.marshaller;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.OutputStreamWriter;
/*     */ import java.io.Writer;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map.Entry;
/*     */ import org.xml.sax.Attributes;
/*     */ import org.xml.sax.SAXException;
/*     */ import org.xml.sax.helpers.AttributesImpl;
/*     */ import org.xml.sax.helpers.XMLFilterImpl;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class XMLWriter
/*     */   extends XMLFilterImpl
/*     */ {
/*     */   public XMLWriter(Writer writer, String encoding, CharacterEscapeHandler _escapeHandler)
/*     */   {
/* 254 */     init(writer, encoding);
/* 255 */     this.escapeHandler = _escapeHandler;
/*     */   }
/*     */   
/*     */   public XMLWriter(Writer writer, String encoding) {
/* 259 */     this(writer, encoding, DumbEscapeHandler.theInstance);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void init(Writer writer, String encoding)
/*     */   {
/* 274 */     setOutput(writer, encoding);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void reset()
/*     */   {
/* 305 */     this.elementLevel = 0;
/* 306 */     this.startTagIsClosed = true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void flush()
/*     */     throws IOException
/*     */   {
/* 327 */     this.output.flush();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setOutput(Writer writer, String _encoding)
/*     */   {
/* 340 */     if (writer == null) {
/* 341 */       this.output = new OutputStreamWriter(System.out);
/*     */     } else {
/* 343 */       this.output = writer;
/*     */     }
/* 345 */     this.encoding = _encoding;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setXmlDecl(boolean _writeXmlDecl)
/*     */   {
/* 355 */     this.writeXmlDecl = _writeXmlDecl;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setHeader(String _header)
/*     */   {
/* 369 */     this.header = _header;
/*     */   }
/*     */   
/*     */ 
/* 373 */   private final HashMap<String, String> locallyDeclaredPrefix = new HashMap();
/*     */   
/* 375 */   public void startPrefixMapping(String prefix, String uri) throws SAXException { this.locallyDeclaredPrefix.put(prefix, uri); }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void startDocument()
/*     */     throws SAXException
/*     */   {
/*     */     try
/*     */     {
/* 397 */       reset();
/*     */       
/* 399 */       if (this.writeXmlDecl) {
/* 400 */         String e = "";
/* 401 */         if (this.encoding != null) {
/* 402 */           e = " encoding=\"" + this.encoding + '"';
/*     */         }
/* 404 */         writeXmlDecl("<?xml version=\"1.0\"" + e + " standalone=\"yes\"?>");
/*     */       }
/*     */       
/* 407 */       if (this.header != null) {
/* 408 */         write(this.header);
/*     */       }
/* 410 */       super.startDocument();
/*     */     } catch (IOException e) {
/* 412 */       throw new SAXException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   protected void writeXmlDecl(String decl) throws IOException {
/* 417 */     write(decl);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void endDocument()
/*     */     throws SAXException
/*     */   {
/*     */     try
/*     */     {
/* 435 */       super.endDocument();
/* 436 */       flush();
/*     */     } catch (IOException e) {
/* 438 */       throw new SAXException(e);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void startElement(String uri, String localName, String qName, Attributes atts)
/*     */     throws SAXException
/*     */   {
/*     */     try
/*     */     {
/* 467 */       if (!this.startTagIsClosed) {
/* 468 */         write(">");
/*     */       }
/* 470 */       this.elementLevel += 1;
/*     */       
/*     */ 
/* 473 */       write('<');
/* 474 */       write(qName);
/* 475 */       writeAttributes(atts);
/*     */       
/*     */ 
/* 478 */       if (!this.locallyDeclaredPrefix.isEmpty()) {
/* 479 */         for (Map.Entry<String, String> e : this.locallyDeclaredPrefix.entrySet()) {
/* 480 */           String p = (String)e.getKey();
/* 481 */           String u = (String)e.getValue();
/* 482 */           if (u == null) {
/* 483 */             u = "";
/*     */           }
/* 485 */           write(' ');
/* 486 */           if ("".equals(p)) {
/* 487 */             write("xmlns=\"");
/*     */           } else {
/* 489 */             write("xmlns:");
/* 490 */             write(p);
/* 491 */             write("=\"");
/*     */           }
/* 493 */           char[] ch = u.toCharArray();
/* 494 */           writeEsc(ch, 0, ch.length, true);
/* 495 */           write('"');
/*     */         }
/* 497 */         this.locallyDeclaredPrefix.clear();
/*     */       }
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 504 */       super.startElement(uri, localName, qName, atts);
/* 505 */       this.startTagIsClosed = false;
/*     */     } catch (IOException e) {
/* 507 */       throw new SAXException(e);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void endElement(String uri, String localName, String qName)
/*     */     throws SAXException
/*     */   {
/*     */     try
/*     */     {
/* 534 */       if (this.startTagIsClosed) {
/* 535 */         write("</");
/* 536 */         write(qName);
/* 537 */         write('>');
/*     */       } else {
/* 539 */         write("/>");
/* 540 */         this.startTagIsClosed = true;
/*     */       }
/* 542 */       super.endElement(uri, localName, qName);
/*     */       
/* 544 */       this.elementLevel -= 1;
/*     */     } catch (IOException e) {
/* 546 */       throw new SAXException(e);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void characters(char[] ch, int start, int len)
/*     */     throws SAXException
/*     */   {
/*     */     try
/*     */     {
/* 568 */       if (!this.startTagIsClosed) {
/* 569 */         write('>');
/* 570 */         this.startTagIsClosed = true;
/*     */       }
/* 572 */       writeEsc(ch, start, len, false);
/* 573 */       super.characters(ch, start, len);
/*     */     } catch (IOException e) {
/* 575 */       throw new SAXException(e);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void ignorableWhitespace(char[] ch, int start, int length)
/*     */     throws SAXException
/*     */   {
/*     */     try
/*     */     {
/* 597 */       writeEsc(ch, start, length, false);
/* 598 */       super.ignorableWhitespace(ch, start, length);
/*     */     } catch (IOException e) {
/* 600 */       throw new SAXException(e);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void processingInstruction(String target, String data)
/*     */     throws SAXException
/*     */   {
/*     */     try
/*     */     {
/* 622 */       if (!this.startTagIsClosed) {
/* 623 */         write('>');
/* 624 */         this.startTagIsClosed = true;
/*     */       }
/* 626 */       write("<?");
/* 627 */       write(target);
/* 628 */       write(' ');
/* 629 */       write(data);
/* 630 */       write("?>");
/* 631 */       if (this.elementLevel < 1) {
/* 632 */         write('\n');
/*     */       }
/* 634 */       super.processingInstruction(target, data);
/*     */     } catch (IOException e) {
/* 636 */       throw new SAXException(e);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void startElement(String uri, String localName)
/*     */     throws SAXException
/*     */   {
/* 667 */     startElement(uri, localName, "", this.EMPTY_ATTS);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void startElement(String localName)
/*     */     throws SAXException
/*     */   {
/* 689 */     startElement("", localName, "", this.EMPTY_ATTS);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void endElement(String uri, String localName)
/*     */     throws SAXException
/*     */   {
/* 710 */     endElement(uri, localName, "");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void endElement(String localName)
/*     */     throws SAXException
/*     */   {
/* 731 */     endElement("", localName, "");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void dataElement(String uri, String localName, String qName, Attributes atts, String content)
/*     */     throws SAXException
/*     */   {
/* 765 */     startElement(uri, localName, qName, atts);
/* 766 */     characters(content);
/* 767 */     endElement(uri, localName, qName);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void dataElement(String uri, String localName, String content)
/*     */     throws SAXException
/*     */   {
/* 798 */     dataElement(uri, localName, "", this.EMPTY_ATTS, content);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void dataElement(String localName, String content)
/*     */     throws SAXException
/*     */   {
/* 829 */     dataElement("", localName, "", this.EMPTY_ATTS, content);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void characters(String data)
/*     */     throws SAXException
/*     */   {
/*     */     try
/*     */     {
/* 848 */       if (!this.startTagIsClosed) {
/* 849 */         write('>');
/* 850 */         this.startTagIsClosed = true;
/*     */       }
/* 852 */       char[] ch = data.toCharArray();
/* 853 */       characters(ch, 0, ch.length);
/*     */     } catch (IOException e) {
/* 855 */       throw new SAXException(e);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final void write(char c)
/*     */     throws IOException
/*     */   {
/* 874 */     this.output.write(c);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected final void write(String s)
/*     */     throws IOException
/*     */   {
/* 882 */     this.output.write(s);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void writeAttributes(Attributes atts)
/*     */     throws IOException
/*     */   {
/* 894 */     int len = atts.getLength();
/* 895 */     for (int i = 0; i < len; i++) {
/* 896 */       char[] ch = atts.getValue(i).toCharArray();
/* 897 */       write(' ');
/* 898 */       write(atts.getQName(i));
/* 899 */       write("=\"");
/* 900 */       writeEsc(ch, 0, ch.length, true);
/* 901 */       write('"');
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void writeEsc(char[] ch, int start, int length, boolean isAttVal)
/*     */     throws IOException
/*     */   {
/* 918 */     this.escapeHandler.escape(ch, start, length, isAttVal, this.output);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 927 */   private final Attributes EMPTY_ATTS = new AttributesImpl();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 935 */   private int elementLevel = 0;
/*     */   private Writer output;
/*     */   private String encoding;
/* 938 */   private boolean writeXmlDecl = true;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 944 */   private String header = null;
/*     */   
/*     */   private final CharacterEscapeHandler escapeHandler;
/*     */   
/* 948 */   private boolean startTagIsClosed = true;
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\marshaller\XMLWriter.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */