/*      */ package com.sun.xml.bind.v2.model.impl;
/*      */ 
/*      */ import com.sun.istack.FinalArrayList;
/*      */ import com.sun.xml.bind.v2.TODO;
/*      */ import com.sun.xml.bind.v2.model.annotation.AnnotationReader;
/*      */ import com.sun.xml.bind.v2.model.annotation.Locatable;
/*      */ import com.sun.xml.bind.v2.model.annotation.MethodLocatable;
/*      */ import com.sun.xml.bind.v2.model.core.ClassInfo;
/*      */ import com.sun.xml.bind.v2.model.core.Element;
/*      */ import com.sun.xml.bind.v2.model.core.ID;
/*      */ import com.sun.xml.bind.v2.model.core.PropertyInfo;
/*      */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*      */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*      */ import com.sun.xml.bind.v2.runtime.IllegalAnnotationException;
/*      */ import com.sun.xml.bind.v2.runtime.Location;
/*      */ import java.lang.annotation.Annotation;
/*      */ import java.lang.reflect.Method;
/*      */ import java.util.Collection;
/*      */ import java.util.Collections;
/*      */ import java.util.Comparator;
/*      */ import java.util.HashMap;
/*      */ import java.util.HashSet;
/*      */ import java.util.LinkedHashMap;
/*      */ import java.util.List;
/*      */ import java.util.Map;
/*      */ import java.util.Map.Entry;
/*      */ import java.util.Set;
/*      */ import java.util.TreeSet;
/*      */ import javax.xml.bind.annotation.XmlAccessOrder;
/*      */ import javax.xml.bind.annotation.XmlAccessType;
/*      */ import javax.xml.bind.annotation.XmlAccessorOrder;
/*      */ import javax.xml.bind.annotation.XmlAccessorType;
/*      */ import javax.xml.bind.annotation.XmlAnyAttribute;
/*      */ import javax.xml.bind.annotation.XmlAnyElement;
/*      */ import javax.xml.bind.annotation.XmlAttachmentRef;
/*      */ import javax.xml.bind.annotation.XmlAttribute;
/*      */ import javax.xml.bind.annotation.XmlElement;
/*      */ import javax.xml.bind.annotation.XmlElementRef;
/*      */ import javax.xml.bind.annotation.XmlElementRefs;
/*      */ import javax.xml.bind.annotation.XmlElementWrapper;
/*      */ import javax.xml.bind.annotation.XmlElements;
/*      */ import javax.xml.bind.annotation.XmlID;
/*      */ import javax.xml.bind.annotation.XmlIDREF;
/*      */ import javax.xml.bind.annotation.XmlInlineBinaryData;
/*      */ import javax.xml.bind.annotation.XmlList;
/*      */ import javax.xml.bind.annotation.XmlMimeType;
/*      */ import javax.xml.bind.annotation.XmlMixed;
/*      */ import javax.xml.bind.annotation.XmlSchemaType;
/*      */ import javax.xml.bind.annotation.XmlTransient;
/*      */ import javax.xml.bind.annotation.XmlType;
/*      */ import javax.xml.bind.annotation.XmlType.DEFAULT;
/*      */ import javax.xml.bind.annotation.XmlValue;
/*      */ import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
/*      */ import javax.xml.namespace.QName;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ class ClassInfoImpl<T, C, F, M>
/*      */   extends TypeInfoImpl<T, C, F, M>
/*      */   implements ClassInfo<T, C>, Element<T, C>
/*      */ {
/*      */   protected final C clazz;
/*      */   private final QName elementName;
/*      */   private final QName typeName;
/*      */   private FinalArrayList<PropertyInfoImpl<T, C, F, M>> properties;
/*      */   private final String[] propOrder;
/*      */   private ClassInfoImpl<T, C, F, M> baseClass;
/*  103 */   private boolean baseClassComputed = false;
/*      */   
/*  105 */   private boolean hasSubClasses = false;
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   protected PropertySeed<T, C, F, M> attributeWildcard;
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*  119 */   private M factoryMethod = null;
/*      */   private static final SecondaryAnnotation[] SECONDARY_ANNOTATIONS;
/*      */   
/*  122 */   ClassInfoImpl(ModelBuilder<T, C, F, M> builder, Locatable upstream, C clazz) { super(builder, upstream);
/*  123 */     this.clazz = clazz;
/*  124 */     assert (clazz != null);
/*      */     
/*      */ 
/*  127 */     this.elementName = parseElementName(clazz);
/*      */     
/*      */ 
/*  130 */     XmlType t = (XmlType)reader().getClassAnnotation(XmlType.class, clazz, this);
/*  131 */     this.typeName = parseTypeName(clazz, t);
/*      */     
/*  133 */     if (t != null) {
/*  134 */       String[] propOrder = t.propOrder();
/*  135 */       if (propOrder.length == 0) {
/*  136 */         this.propOrder = null;
/*      */       }
/*  138 */       else if (propOrder[0].length() == 0) {
/*  139 */         this.propOrder = DEFAULT_ORDER;
/*      */       } else {
/*  141 */         this.propOrder = propOrder;
/*      */       }
/*      */     } else {
/*  144 */       this.propOrder = DEFAULT_ORDER;
/*      */     }
/*      */     
/*      */ 
/*  148 */     if ((!hasFactoryConstructor(t)) && 
/*  149 */       (!nav().hasDefaultConstructor(clazz))) { Messages msg;
/*      */       Messages msg;
/*  151 */       if (nav().isInterface(clazz)) {
/*  152 */         msg = Messages.CANT_HANDLE_INTERFACE;
/*      */       } else {
/*  154 */         msg = Messages.NO_DEFAULT_CONSTRUCTOR;
/*      */       }
/*  156 */       builder.reportError(new IllegalAnnotationException(msg.format(new Object[] { nav().getClassName(clazz) }), this));
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   public ClassInfoImpl<T, C, F, M> getBaseClass()
/*      */   {
/*  163 */     if (!this.baseClassComputed) {
/*  164 */       this.baseClassComputed = true;
/*      */       
/*  166 */       C s = nav().getSuperClass(this.clazz);
/*  167 */       if ((s == null) || (s == nav().asDecl(Object.class))) {
/*  168 */         this.baseClass = null;
/*      */       } else {
/*  170 */         this.baseClass = ((ClassInfoImpl)this.builder.getClassInfo(s, this));
/*  171 */         this.baseClass.hasSubClasses = true;
/*      */       }
/*      */     }
/*  174 */     return this.baseClass;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public final Element<T, C> getSubstitutionHead()
/*      */   {
/*  183 */     ClassInfoImpl<T, C, F, M> c = getBaseClass();
/*  184 */     while ((c != null) && (!c.isElement()))
/*  185 */       c = c.getBaseClass();
/*  186 */     return c;
/*      */   }
/*      */   
/*      */   public final C getClazz() {
/*  190 */     return (C)this.clazz;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   /**
/*      */    * @deprecated
/*      */    */
/*      */   public ClassInfoImpl<T, C, F, M> getScope()
/*      */   {
/*  201 */     return null;
/*      */   }
/*      */   
/*      */   public final T getType() {
/*  205 */     return (T)nav().use(this.clazz);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   public boolean canBeReferencedByIDREF()
/*      */   {
/*  213 */     for (PropertyInfo<T, C> p : getProperties()) {
/*  214 */       if (p.id() == ID.ID)
/*  215 */         return true;
/*      */     }
/*  217 */     ClassInfoImpl<T, C, F, M> base = getBaseClass();
/*  218 */     if (base != null) {
/*  219 */       return base.canBeReferencedByIDREF();
/*      */     }
/*  221 */     return false;
/*      */   }
/*      */   
/*      */   public final String getName() {
/*  225 */     return nav().getClassName(this.clazz);
/*      */   }
/*      */   
/*      */   public <A extends Annotation> A readAnnotation(Class<A> a) {
/*  229 */     return reader().getClassAnnotation(a, this.clazz, this);
/*      */   }
/*      */   
/*      */   public Element<T, C> asElement() {
/*  233 */     if (isElement()) {
/*  234 */       return this;
/*      */     }
/*  236 */     return null;
/*      */   }
/*      */   
/*      */   public List<? extends PropertyInfo<T, C>> getProperties() {
/*  240 */     if (this.properties != null) { return this.properties;
/*      */     }
/*      */     
/*  243 */     XmlAccessType at = getAccessType();
/*      */     
/*  245 */     this.properties = new FinalArrayList();
/*      */     
/*      */ 
/*  248 */     for (F f : nav().getDeclaredFields(this.clazz)) {
/*  249 */       Annotation[] annotations = reader().getAllFieldAnnotations(f, this);
/*  250 */       if (nav().isTransient(f))
/*      */       {
/*  252 */         if (hasJAXBAnnotation(annotations)) {
/*  253 */           this.builder.reportError(new IllegalAnnotationException(Messages.TRANSIENT_FIELD_NOT_BINDABLE.format(new Object[] { nav().getFieldName(f) }), getSomeJAXBAnnotation(annotations)));
/*      */         }
/*      */         
/*      */       }
/*  257 */       else if (nav().isStaticField(f))
/*      */       {
/*  259 */         if (hasJAXBAnnotation(annotations))
/*  260 */           addProperty(createFieldSeed(f), annotations);
/*      */       } else {
/*  262 */         if ((at == XmlAccessType.FIELD) || ((at == XmlAccessType.PUBLIC_MEMBER) && (nav().isPublicField(f))) || (hasJAXBAnnotation(annotations)))
/*      */         {
/*      */ 
/*  265 */           addProperty(createFieldSeed(f), annotations); }
/*  266 */         checkFieldXmlLocation(f);
/*      */       }
/*      */     }
/*      */     
/*  270 */     findGetterSetterProperties(at);
/*      */     
/*  272 */     if ((this.propOrder == DEFAULT_ORDER) || (this.propOrder == null)) {
/*  273 */       XmlAccessOrder ao = getAccessorOrder();
/*  274 */       if (ao == XmlAccessOrder.ALPHABETICAL) {
/*  275 */         Collections.sort(this.properties);
/*      */       }
/*      */     } else {
/*  278 */       ClassInfoImpl<T, C, F, M>.PropertySorter sorter = new PropertySorter();
/*  279 */       for (PropertyInfoImpl p : this.properties)
/*  280 */         sorter.checkedGet(p);
/*  281 */       Collections.sort(this.properties, sorter);
/*  282 */       sorter.checkUnusedProperties();
/*      */     }
/*      */     
/*      */ 
/*  286 */     PropertyInfoImpl vp = null;
/*  287 */     PropertyInfoImpl ep = null;
/*      */     
/*  289 */     for (PropertyInfoImpl p : this.properties) {
/*  290 */       switch (p.kind()) {
/*      */       case ELEMENT: 
/*      */       case REFERENCE: 
/*      */       case MAP: 
/*  294 */         ep = p;
/*  295 */         break;
/*      */       case VALUE: 
/*  297 */         if (vp != null)
/*      */         {
/*  299 */           this.builder.reportError(new IllegalAnnotationException(Messages.MULTIPLE_VALUE_PROPERTY.format(new Object[0]), vp, p));
/*      */         }
/*      */         
/*      */ 
/*  303 */         if (getBaseClass() != null) {
/*  304 */           this.builder.reportError(new IllegalAnnotationException(Messages.XMLVALUE_IN_DERIVED_TYPE.format(new Object[0]), p));
/*      */         }
/*      */         
/*  307 */         vp = p;
/*  308 */         break;
/*      */       case ATTRIBUTE: 
/*      */         break;
/*      */       default: 
/*  312 */         if (!$assertionsDisabled) throw new AssertionError();
/*      */         break;
/*      */       }
/*      */     }
/*  316 */     if ((ep != null) && (vp != null))
/*      */     {
/*  318 */       this.builder.reportError(new IllegalAnnotationException(Messages.ELEMENT_AND_VALUE_PROPERTY.format(new Object[0]), vp, ep));
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*  325 */     return this.properties;
/*      */   }
/*      */   
/*      */   public PropertyInfo<T, C> getProperty(String name) {
/*  329 */     for (PropertyInfo<T, C> p : getProperties()) {
/*  330 */       if (p.getName().equals(name))
/*  331 */         return p;
/*      */     }
/*  333 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private <T extends Annotation> T getClassOrPackageAnnotation(Class<T> type)
/*      */   {
/*  346 */     T t = reader().getClassAnnotation(type, this.clazz, this);
/*  347 */     if (t != null) {
/*  348 */       return t;
/*      */     }
/*  350 */     return reader().getPackageAnnotation(type, this.clazz, this);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   private XmlAccessType getAccessType()
/*      */   {
/*  358 */     XmlAccessorType xat = (XmlAccessorType)getClassOrPackageAnnotation(XmlAccessorType.class);
/*  359 */     if (xat != null) {
/*  360 */       return xat.value();
/*      */     }
/*  362 */     return XmlAccessType.PUBLIC_MEMBER;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private XmlAccessOrder getAccessorOrder()
/*      */   {
/*  369 */     XmlAccessorOrder xao = (XmlAccessorOrder)getClassOrPackageAnnotation(XmlAccessorOrder.class);
/*  370 */     if (xao != null) {
/*  371 */       return xao.value();
/*      */     }
/*  373 */     return XmlAccessOrder.UNDEFINED;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private final class PropertySorter
/*      */     extends HashMap<String, Integer>
/*      */     implements Comparator<PropertyInfoImpl>
/*      */   {
/*  386 */     PropertyInfoImpl[] used = new PropertyInfoImpl[ClassInfoImpl.this.propOrder.length];
/*      */     
/*      */ 
/*      */     private Set<String> collidedNames;
/*      */     
/*      */ 
/*      */ 
/*      */     PropertySorter()
/*      */     {
/*  395 */       super();
/*  396 */       for (String name : ClassInfoImpl.this.propOrder) {
/*  397 */         if (put(name, Integer.valueOf(size())) != null)
/*      */         {
/*  399 */           ClassInfoImpl.this.builder.reportError(new IllegalAnnotationException(Messages.DUPLICATE_ENTRY_IN_PROP_ORDER.format(new Object[] { name }), ClassInfoImpl.this));
/*      */         }
/*      */       }
/*      */     }
/*      */     
/*      */     public int compare(PropertyInfoImpl o1, PropertyInfoImpl o2) {
/*  405 */       int lhs = checkedGet(o1);
/*  406 */       int rhs = checkedGet(o2);
/*      */       
/*  408 */       return lhs - rhs;
/*      */     }
/*      */     
/*      */     private int checkedGet(PropertyInfoImpl p) {
/*  412 */       Integer i = (Integer)get(p.getName());
/*  413 */       if (i == null)
/*      */       {
/*  415 */         if (p.kind().isOrdered) {
/*  416 */           ClassInfoImpl.this.builder.reportError(new IllegalAnnotationException(Messages.PROPERTY_MISSING_FROM_ORDER.format(new Object[] { p.getName() }), p));
/*      */         }
/*      */         
/*      */ 
/*  420 */         i = Integer.valueOf(size());
/*  421 */         put(p.getName(), i);
/*      */       }
/*      */       
/*      */ 
/*  425 */       int ii = i.intValue();
/*  426 */       if (ii < this.used.length) {
/*  427 */         if ((this.used[ii] != null) && (this.used[ii] != p)) {
/*  428 */           if (this.collidedNames == null) { this.collidedNames = new HashSet();
/*      */           }
/*  430 */           if (this.collidedNames.add(p.getName()))
/*      */           {
/*  432 */             ClassInfoImpl.this.builder.reportError(new IllegalAnnotationException(Messages.DUPLICATE_PROPERTIES.format(new Object[] { p.getName() }), p, this.used[ii]));
/*      */           }
/*      */         }
/*  435 */         this.used[ii] = p;
/*      */       }
/*      */       
/*  438 */       return i.intValue();
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */     public void checkUnusedProperties()
/*      */     {
/*  445 */       for (int i = 0; i < this.used.length; i++) {
/*  446 */         if (this.used[i] == null) {
/*  447 */           String unusedName = ClassInfoImpl.this.propOrder[i];
/*  448 */           ClassInfoImpl.this.builder.reportError(new IllegalAnnotationException(Messages.PROPERTY_ORDER_CONTAINS_UNUSED_ENTRY.format(new Object[] { unusedName }), ClassInfoImpl.this));
/*      */         }
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */   public boolean hasProperties() {
/*  455 */     return !this.properties.isEmpty();
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   private static <T> T pickOne(T... args)
/*      */   {
/*  463 */     for (T arg : args)
/*  464 */       if (arg != null)
/*  465 */         return arg;
/*  466 */     return null;
/*      */   }
/*      */   
/*      */   private static <T> List<T> makeSet(T... args) {
/*  470 */     List<T> l = new FinalArrayList();
/*  471 */     for (T arg : args)
/*  472 */       if (arg != null) l.add(arg);
/*  473 */     return l;
/*      */   }
/*      */   
/*      */   private static final class ConflictException
/*      */     extends Exception {
/*      */     final List<Annotation> annotations;
/*      */     
/*  480 */     public ConflictException(List<Annotation> one) { this.annotations = one; }
/*      */   }
/*      */   
/*      */   private static final class DupliateException extends Exception {
/*      */     final Annotation a1;
/*      */     final Annotation a2;
/*      */     
/*  487 */     public DupliateException(Annotation a1, Annotation a2) { this.a1 = a1;
/*  488 */       this.a2 = a2;
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private static enum SecondaryAnnotation
/*      */   {
/*  496 */     JAVA_TYPE(1, new Class[] { XmlJavaTypeAdapter.class }), 
/*  497 */     ID_IDREF(2, new Class[] { XmlID.class, XmlIDREF.class }), 
/*  498 */     BINARY(4, new Class[] { XmlInlineBinaryData.class, XmlMimeType.class, XmlAttachmentRef.class }), 
/*  499 */     ELEMENT_WRAPPER(8, new Class[] { XmlElementWrapper.class }), 
/*  500 */     LIST(16, new Class[] { XmlList.class }), 
/*  501 */     SCHEMA_TYPE(32, new Class[] { XmlSchemaType.class });
/*      */     
/*      */ 
/*      */ 
/*      */     final int bitMask;
/*      */     
/*      */ 
/*      */     final Class<? extends Annotation>[] members;
/*      */     
/*      */ 
/*      */ 
/*      */     private SecondaryAnnotation(int bitMask, Class<? extends Annotation>... members)
/*      */     {
/*  514 */       this.bitMask = bitMask;
/*  515 */       this.members = members;
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private static enum PropertyGroup
/*      */   {
/*  528 */     TRANSIENT(new boolean[] { false, false, false, false, false, false }), 
/*  529 */     ANY_ATTRIBUTE(new boolean[] { true, false, false, false, false, false }), 
/*  530 */     ATTRIBUTE(new boolean[] { true, true, true, false, true, true }), 
/*  531 */     VALUE(new boolean[] { true, true, true, false, true, true }), 
/*  532 */     ELEMENT(new boolean[] { true, true, true, true, true, true }), 
/*  533 */     ELEMENT_REF(new boolean[] { true, false, false, true, false, false }), 
/*  534 */     MAP(new boolean[] { false, false, false, true, false, false });
/*      */     
/*      */ 
/*      */ 
/*      */     final int allowedsecondaryAnnotations;
/*      */     
/*      */ 
/*      */ 
/*      */     private PropertyGroup(boolean... bits)
/*      */     {
/*  544 */       int mask = 0;
/*  545 */       assert (bits.length == ClassInfoImpl.SECONDARY_ANNOTATIONS.length);
/*  546 */       for (int i = 0; i < bits.length; i++) {
/*  547 */         if (bits[i] != 0)
/*  548 */           mask |= ClassInfoImpl.SECONDARY_ANNOTATIONS[i].bitMask;
/*      */       }
/*  550 */       this.allowedsecondaryAnnotations = (mask ^ 0xFFFFFFFF);
/*      */     }
/*      */     
/*      */     boolean allows(ClassInfoImpl.SecondaryAnnotation a) {
/*  554 */       return (this.allowedsecondaryAnnotations & a.bitMask) == 0;
/*      */     }
/*      */   }
/*      */   
/*      */   static
/*      */   {
/*  519 */     SECONDARY_ANNOTATIONS = SecondaryAnnotation.values();
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*  558 */     EMPTY_ANNOTATIONS = new Annotation[0];
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*  563 */     ANNOTATION_NUMBER_MAP = new HashMap();
/*      */     
/*  565 */     Class[] annotations = { XmlTransient.class, XmlAnyAttribute.class, XmlAttribute.class, XmlValue.class, XmlElement.class, XmlElements.class, XmlElementRef.class, XmlElementRefs.class, XmlAnyElement.class, XmlMixed.class };
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*  578 */     HashMap<Class, Integer> m = ANNOTATION_NUMBER_MAP;
/*      */     
/*      */ 
/*  581 */     for (Class c : annotations) {
/*  582 */       m.put(c, Integer.valueOf(m.size()));
/*      */     }
/*      */     
/*  585 */     int index = 20;
/*  586 */     for (SecondaryAnnotation sa : SECONDARY_ANNOTATIONS) {
/*  587 */       for (Class member : sa.members)
/*  588 */         m.put(member, Integer.valueOf(index));
/*  589 */       index++;
/*      */     }
/*      */   }
/*      */   
/*      */   private void checkConflict(Annotation a, Annotation b) throws ClassInfoImpl.DupliateException {
/*  594 */     assert (b != null);
/*  595 */     if (a != null) {
/*  596 */       throw new DupliateException(a, b);
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private static final Annotation[] EMPTY_ANNOTATIONS;
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private static final HashMap<Class, Integer> ANNOTATION_NUMBER_MAP;
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private void addProperty(PropertySeed<T, C, F, M> seed, Annotation[] annotations)
/*      */   {
/*  619 */     XmlTransient t = null;
/*  620 */     XmlAnyAttribute aa = null;
/*  621 */     XmlAttribute a = null;
/*  622 */     XmlValue v = null;
/*  623 */     XmlElement e1 = null;
/*  624 */     XmlElements e2 = null;
/*  625 */     XmlElementRef r1 = null;
/*  626 */     XmlElementRefs r2 = null;
/*  627 */     XmlAnyElement xae = null;
/*  628 */     XmlMixed mx = null;
/*      */     
/*      */ 
/*  631 */     int secondaryAnnotations = 0;
/*      */     try
/*      */     {
/*  634 */       for (Annotation ann : annotations) {
/*  635 */         Integer index = (Integer)ANNOTATION_NUMBER_MAP.get(ann.annotationType());
/*  636 */         if (index != null) {
/*  637 */           switch (index.intValue()) {
/*  638 */           case 0:  checkConflict(t, ann);t = (XmlTransient)ann; break;
/*  639 */           case 1:  checkConflict(aa, ann);aa = (XmlAnyAttribute)ann; break;
/*  640 */           case 2:  checkConflict(a, ann);a = (XmlAttribute)ann; break;
/*  641 */           case 3:  checkConflict(v, ann);v = (XmlValue)ann; break;
/*  642 */           case 4:  checkConflict(e1, ann);e1 = (XmlElement)ann; break;
/*  643 */           case 5:  checkConflict(e2, ann);e2 = (XmlElements)ann; break;
/*  644 */           case 6:  checkConflict(r1, ann);r1 = (XmlElementRef)ann; break;
/*  645 */           case 7:  checkConflict(r2, ann);r2 = (XmlElementRefs)ann; break;
/*  646 */           case 8:  checkConflict(xae, ann);xae = (XmlAnyElement)ann; break;
/*  647 */           case 9:  checkConflict(mx, ann);mx = (XmlMixed)ann; break;
/*      */           
/*      */           default: 
/*  650 */             secondaryAnnotations |= 1 << index.intValue() - 20;
/*      */           }
/*      */           
/*      */         }
/*      */       }
/*      */       
/*      */ 
/*  657 */       PropertyGroup group = null;
/*  658 */       int groupCount = 0;
/*      */       
/*  660 */       if (t != null) {
/*  661 */         group = PropertyGroup.TRANSIENT;
/*  662 */         groupCount++;
/*      */       }
/*  664 */       if (aa != null) {
/*  665 */         group = PropertyGroup.ANY_ATTRIBUTE;
/*  666 */         groupCount++;
/*      */       }
/*  668 */       if (a != null) {
/*  669 */         group = PropertyGroup.ATTRIBUTE;
/*  670 */         groupCount++;
/*      */       }
/*  672 */       if (v != null) {
/*  673 */         group = PropertyGroup.VALUE;
/*  674 */         groupCount++;
/*      */       }
/*  676 */       if ((e1 != null) || (e2 != null)) {
/*  677 */         group = PropertyGroup.ELEMENT;
/*  678 */         groupCount++;
/*      */       }
/*  680 */       if ((r1 != null) || (r2 != null) || (xae != null) || (mx != null)) {
/*  681 */         group = PropertyGroup.ELEMENT_REF;
/*  682 */         groupCount++;
/*      */       }
/*      */       
/*  685 */       if (groupCount > 1)
/*      */       {
/*  687 */         List<Annotation> err = makeSet(new Annotation[] { t, aa, a, v, (Annotation)pickOne(new Annotation[] { e1, e2 }), (Annotation)pickOne(new Annotation[] { r1, r2, xae }) });
/*  688 */         throw new ConflictException(err);
/*      */       }
/*      */       
/*  691 */       if (group == null)
/*      */       {
/*      */ 
/*  694 */         assert (groupCount == 0);
/*      */         
/*      */ 
/*  697 */         if ((nav().isSubClassOf(seed.getRawType(), nav().ref(Map.class))) && (!seed.hasAnnotation(XmlJavaTypeAdapter.class)))
/*      */         {
/*  699 */           group = PropertyGroup.MAP;
/*      */         } else {
/*  701 */           group = PropertyGroup.ELEMENT;
/*      */         }
/*      */       }
/*      */       
/*      */ 
/*  706 */       if ((secondaryAnnotations & group.allowedsecondaryAnnotations) != 0)
/*      */       {
/*  708 */         for (SecondaryAnnotation sa : SECONDARY_ANNOTATIONS) {
/*  709 */           if (!group.allows(sa))
/*      */           {
/*  711 */             for (Class<? extends Annotation> m : sa.members) {
/*  712 */               Annotation offender = seed.readAnnotation(m);
/*  713 */               if (offender != null)
/*      */               {
/*  715 */                 this.builder.reportError(new IllegalAnnotationException(Messages.ANNOTATION_NOT_ALLOWED.format(new Object[] { m.getSimpleName() }), offender));
/*      */                 
/*  717 */                 return;
/*      */               }
/*      */             }
/*      */           }
/*      */         }
/*  722 */         if (!$assertionsDisabled) { throw new AssertionError();
/*      */         }
/*      */       }
/*      */       
/*  726 */       switch (group) {
/*      */       case TRANSIENT: 
/*  728 */         return;
/*      */       
/*      */       case ANY_ATTRIBUTE: 
/*  731 */         if (this.attributeWildcard != null) {
/*  732 */           this.builder.reportError(new IllegalAnnotationException(Messages.TWO_ATTRIBUTE_WILDCARDS.format(new Object[] { nav().getClassName(getClazz()) }), aa, this.attributeWildcard));
/*      */           
/*      */ 
/*  735 */           return;
/*      */         }
/*  737 */         this.attributeWildcard = seed;
/*      */         
/*  739 */         if (inheritsAttributeWildcard()) {
/*  740 */           this.builder.reportError(new IllegalAnnotationException(Messages.SUPER_CLASS_HAS_WILDCARD.format(new Object[0]), aa, getInheritedAttributeWildcard()));
/*      */           
/*      */ 
/*  743 */           return;
/*      */         }
/*      */         
/*      */ 
/*  747 */         if (!nav().isSubClassOf(seed.getRawType(), nav().ref(Map.class))) {
/*  748 */           this.builder.reportError(new IllegalAnnotationException(Messages.INVALID_ATTRIBUTE_WILDCARD_TYPE.format(new Object[] { nav().getTypeName(seed.getRawType()) }), aa, getInheritedAttributeWildcard()));
/*      */           
/*      */ 
/*  751 */           return;
/*      */         }
/*      */         
/*      */ 
/*  755 */         return;
/*      */       case ATTRIBUTE: 
/*  757 */         this.properties.add(createAttributeProperty(seed));
/*  758 */         return;
/*      */       case VALUE: 
/*  760 */         this.properties.add(createValueProperty(seed));
/*  761 */         return;
/*      */       case ELEMENT: 
/*  763 */         this.properties.add(createElementProperty(seed));
/*  764 */         return;
/*      */       case ELEMENT_REF: 
/*  766 */         this.properties.add(createReferenceProperty(seed));
/*  767 */         return;
/*      */       case MAP: 
/*  769 */         this.properties.add(createMapProperty(seed));
/*  770 */         return;
/*      */       }
/*  772 */       if (!$assertionsDisabled) throw new AssertionError();
/*      */     }
/*      */     catch (ConflictException x)
/*      */     {
/*  776 */       List<Annotation> err = x.annotations;
/*      */       
/*  778 */       this.builder.reportError(new IllegalAnnotationException(Messages.MUTUALLY_EXCLUSIVE_ANNOTATIONS.format(new Object[] { nav().getClassName(getClazz()) + '#' + seed.getName(), ((Annotation)err.get(0)).annotationType().getName(), ((Annotation)err.get(1)).annotationType().getName() }), (Annotation)err.get(0), (Annotation)err.get(1)));
/*      */ 
/*      */ 
/*      */ 
/*      */     }
/*      */     catch (DupliateException e)
/*      */     {
/*      */ 
/*      */ 
/*  787 */       this.builder.reportError(new IllegalAnnotationException(Messages.DUPLICATE_ANNOTATIONS.format(new Object[] { e.a1.annotationType().getName() }), e.a1, e.a2));
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   protected ReferencePropertyInfoImpl<T, C, F, M> createReferenceProperty(PropertySeed<T, C, F, M> seed)
/*      */   {
/*  796 */     return new ReferencePropertyInfoImpl(this, seed);
/*      */   }
/*      */   
/*      */   protected AttributePropertyInfoImpl<T, C, F, M> createAttributeProperty(PropertySeed<T, C, F, M> seed) {
/*  800 */     return new AttributePropertyInfoImpl(this, seed);
/*      */   }
/*      */   
/*      */   protected ValuePropertyInfoImpl<T, C, F, M> createValueProperty(PropertySeed<T, C, F, M> seed) {
/*  804 */     return new ValuePropertyInfoImpl(this, seed);
/*      */   }
/*      */   
/*      */   protected ElementPropertyInfoImpl<T, C, F, M> createElementProperty(PropertySeed<T, C, F, M> seed) {
/*  808 */     return new ElementPropertyInfoImpl(this, seed);
/*      */   }
/*      */   
/*      */   protected MapPropertyInfoImpl<T, C, F, M> createMapProperty(PropertySeed<T, C, F, M> seed) {
/*  812 */     return new MapPropertyInfoImpl(this, seed);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   private void findGetterSetterProperties(XmlAccessType at)
/*      */   {
/*  820 */     TODO.checkSpec();
/*      */     
/*      */ 
/*      */ 
/*  824 */     Map<String, M> getters = new LinkedHashMap();
/*  825 */     Map<String, M> setters = new LinkedHashMap();
/*      */     
/*  827 */     Collection<? extends M> methods = nav().getDeclaredMethods(this.clazz);
/*  828 */     for (M method : methods) {
/*  829 */       boolean used = false;
/*      */       
/*  831 */       if (!nav().isBridgeMethod(method))
/*      */       {
/*      */ 
/*  834 */         String name = nav().getMethodName(method);
/*  835 */         int arity = nav().getMethodParameters(method).length;
/*      */         
/*  837 */         if (nav().isStaticMethod(method)) {
/*  838 */           ensureNoAnnotation(method);
/*      */ 
/*      */ 
/*      */         }
/*      */         else
/*      */         {
/*      */ 
/*  845 */           String propName = getPropertyNameFromGetMethod(name);
/*  846 */           if ((propName != null) && 
/*  847 */             (arity == 0)) {
/*  848 */             getters.put(propName, method);
/*  849 */             used = true;
/*      */           }
/*      */           
/*      */ 
/*      */ 
/*      */ 
/*  855 */           propName = getPropertyNameFromSetMethod(name);
/*  856 */           if ((propName != null) && 
/*  857 */             (arity == 1))
/*      */           {
/*  859 */             setters.put(propName, method);
/*  860 */             used = true;
/*      */           }
/*      */           
/*      */ 
/*      */ 
/*  865 */           if (!used)
/*  866 */             ensureNoAnnotation(method);
/*      */         }
/*      */       }
/*      */     }
/*  870 */     Set<String> complete = new TreeSet(getters.keySet());
/*  871 */     complete.retainAll(setters.keySet());
/*      */     
/*  873 */     resurrect(getters, complete);
/*  874 */     resurrect(setters, complete);
/*      */     
/*      */ 
/*  877 */     for (String name : complete) {
/*  878 */       M getter = getters.get(name);
/*  879 */       M setter = setters.get(name);
/*      */       
/*  881 */       Annotation[] ga = getter != null ? reader().getAllMethodAnnotations(getter, new MethodLocatable(this, getter, nav())) : EMPTY_ANNOTATIONS;
/*  882 */       Annotation[] sa = setter != null ? reader().getAllMethodAnnotations(setter, new MethodLocatable(this, setter, nav())) : EMPTY_ANNOTATIONS;
/*      */       
/*  884 */       boolean hasAnnotation = (hasJAXBAnnotation(ga)) || (hasJAXBAnnotation(sa));
/*  885 */       boolean isOverriding = false;
/*  886 */       if (!hasAnnotation)
/*      */       {
/*      */ 
/*  889 */         isOverriding = ((getter != null) && (nav().isOverriding(getter))) || ((setter != null) && (nav().isOverriding(setter)));
/*      */       }
/*      */       
/*      */ 
/*  893 */       if (((at == XmlAccessType.PROPERTY) && (!isOverriding)) || ((at == XmlAccessType.PUBLIC_MEMBER) && (isConsideredPublic(getter)) && (isConsideredPublic(setter)) && (!isOverriding)) || (hasAnnotation))
/*      */       {
/*      */ 
/*      */ 
/*  897 */         if ((getter != null) && (setter != null) && (!nav().getReturnType(getter).equals(nav().getMethodParameters(setter)[0])))
/*      */         {
/*      */ 
/*  900 */           this.builder.reportError(new IllegalAnnotationException(Messages.GETTER_SETTER_INCOMPATIBLE_TYPE.format(new Object[] { nav().getTypeName(nav().getReturnType(getter)), nav().getTypeName(nav().getMethodParameters(setter)[0]) }), new MethodLocatable(this, getter, nav()), new MethodLocatable(this, setter, nav())));
/*      */         }
/*      */         else
/*      */         {
/*      */           Annotation[] r;
/*      */           
/*      */ 
/*      */ 
/*      */           Annotation[] r;
/*      */           
/*      */ 
/*      */ 
/*  912 */           if (ga.length == 0) {
/*  913 */             r = sa;
/*      */           } else { Annotation[] r;
/*  915 */             if (sa.length == 0) {
/*  916 */               r = ga;
/*      */             } else {
/*  918 */               r = new Annotation[ga.length + sa.length];
/*  919 */               System.arraycopy(ga, 0, r, 0, ga.length);
/*  920 */               System.arraycopy(sa, 0, r, ga.length, sa.length);
/*      */             }
/*      */           }
/*  923 */           addProperty(createAccessorSeed(getter, setter), r);
/*      */         }
/*      */       }
/*      */     }
/*  927 */     getters.keySet().removeAll(complete);
/*  928 */     setters.keySet().removeAll(complete);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private boolean isConsideredPublic(M m)
/*      */   {
/*  944 */     return (m == null) || (nav().isPublicMethod(m));
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   private void resurrect(Map<String, M> methods, Set<String> complete)
/*      */   {
/*  952 */     for (Map.Entry<String, M> e : methods.entrySet()) {
/*  953 */       if (!complete.contains(e.getKey()))
/*      */       {
/*  955 */         if (hasJAXBAnnotation(reader().getAllMethodAnnotations(e.getValue(), this))) {
/*  956 */           complete.add(e.getKey());
/*      */         }
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   private void ensureNoAnnotation(M method)
/*      */   {
/*  965 */     Annotation[] annotations = reader().getAllMethodAnnotations(method, this);
/*  966 */     for (Annotation a : annotations) {
/*  967 */       if (isJAXBAnnotation(a)) {
/*  968 */         this.builder.reportError(new IllegalAnnotationException(Messages.ANNOTATION_ON_WRONG_METHOD.format(new Object[0]), a));
/*      */         
/*      */ 
/*  971 */         return;
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private static boolean isJAXBAnnotation(Annotation a)
/*      */   {
/*  980 */     return ANNOTATION_NUMBER_MAP.containsKey(a.annotationType());
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private static boolean hasJAXBAnnotation(Annotation[] annotations)
/*      */   {
/*  987 */     return getSomeJAXBAnnotation(annotations) != null;
/*      */   }
/*      */   
/*      */   private static Annotation getSomeJAXBAnnotation(Annotation[] annotations) {
/*  991 */     for (Annotation a : annotations)
/*  992 */       if (isJAXBAnnotation(a))
/*  993 */         return a;
/*  994 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private static String getPropertyNameFromGetMethod(String name)
/*      */   {
/* 1005 */     if ((name.startsWith("get")) && (name.length() > 3))
/* 1006 */       return name.substring(3);
/* 1007 */     if ((name.startsWith("is")) && (name.length() > 2))
/* 1008 */       return name.substring(2);
/* 1009 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private static String getPropertyNameFromSetMethod(String name)
/*      */   {
/* 1019 */     if ((name.startsWith("set")) && (name.length() > 3))
/* 1020 */       return name.substring(3);
/* 1021 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   protected PropertySeed<T, C, F, M> createFieldSeed(F f)
/*      */   {
/* 1031 */     return new FieldPropertySeed(this, f);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   protected PropertySeed<T, C, F, M> createAccessorSeed(M getter, M setter)
/*      */   {
/* 1038 */     return new GetterSetterPropertySeed(this, getter, setter);
/*      */   }
/*      */   
/*      */   public final boolean isElement() {
/* 1042 */     return this.elementName != null;
/*      */   }
/*      */   
/*      */   public boolean isAbstract() {
/* 1046 */     return nav().isAbstract(this.clazz);
/*      */   }
/*      */   
/*      */   public boolean isOrdered() {
/* 1050 */     return this.propOrder != null;
/*      */   }
/*      */   
/*      */   public final boolean isFinal() {
/* 1054 */     return nav().isFinal(this.clazz);
/*      */   }
/*      */   
/*      */   public final boolean hasSubClasses() {
/* 1058 */     return this.hasSubClasses;
/*      */   }
/*      */   
/*      */   public final boolean hasAttributeWildcard() {
/* 1062 */     return (declaresAttributeWildcard()) || (inheritsAttributeWildcard());
/*      */   }
/*      */   
/*      */   public final boolean inheritsAttributeWildcard() {
/* 1066 */     return getInheritedAttributeWildcard() != null;
/*      */   }
/*      */   
/*      */   public final boolean declaresAttributeWildcard() {
/* 1070 */     return this.attributeWildcard != null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private PropertySeed<T, C, F, M> getInheritedAttributeWildcard()
/*      */   {
/* 1077 */     for (ClassInfoImpl<T, C, F, M> c = getBaseClass(); c != null; c = c.getBaseClass())
/* 1078 */       if (c.attributeWildcard != null)
/* 1079 */         return c.attributeWildcard;
/* 1080 */     return null;
/*      */   }
/*      */   
/*      */   public final QName getElementName() {
/* 1084 */     return this.elementName;
/*      */   }
/*      */   
/*      */   public final QName getTypeName() {
/* 1088 */     return this.typeName;
/*      */   }
/*      */   
/*      */   public final boolean isSimpleType() {
/* 1092 */     List<? extends PropertyInfo> props = getProperties();
/* 1093 */     if (props.size() != 1) return false;
/* 1094 */     return ((PropertyInfo)props.get(0)).kind() == PropertyKind.VALUE;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   void link()
/*      */   {
/* 1102 */     getProperties();
/*      */     
/*      */ 
/* 1105 */     Map<String, PropertyInfoImpl> names = new HashMap();
/* 1106 */     for (PropertyInfoImpl<T, C, F, M> p : this.properties) {
/* 1107 */       p.link();
/* 1108 */       PropertyInfoImpl old = (PropertyInfoImpl)names.put(p.getName(), p);
/* 1109 */       if (old != null) {
/* 1110 */         this.builder.reportError(new IllegalAnnotationException(Messages.PROPERTY_COLLISION.format(new Object[] { p.getName() }), p, old));
/*      */       }
/*      */     }
/*      */     
/*      */ 
/* 1115 */     super.link();
/*      */   }
/*      */   
/*      */   public Location getLocation() {
/* 1119 */     return nav().getClassLocation(this.clazz);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private boolean hasFactoryConstructor(XmlType t)
/*      */   {
/* 1131 */     if (t == null) { return false;
/*      */     }
/* 1133 */     String method = t.factoryMethod();
/* 1134 */     T fClass = reader().getClassValue(t, "factoryClass");
/* 1135 */     if (method.length() > 0) {
/* 1136 */       if (fClass.equals(nav().ref(XmlType.DEFAULT.class))) {
/* 1137 */         fClass = nav().use(this.clazz);
/*      */       }
/* 1139 */       for (M m : nav().getDeclaredMethods(nav().asDecl(fClass)))
/*      */       {
/* 1141 */         if ((nav().getMethodName(m).equals(method)) && (nav().getReturnType(m).equals(nav().use(this.clazz))) && (nav().getMethodParameters(m).length == 0) && (nav().isStaticMethod(m)))
/*      */         {
/*      */ 
/*      */ 
/* 1145 */           this.factoryMethod = m;
/* 1146 */           break;
/*      */         }
/*      */       }
/* 1149 */       if (this.factoryMethod == null) {
/* 1150 */         this.builder.reportError(new IllegalAnnotationException(Messages.NO_FACTORY_METHOD.format(new Object[] { nav().getClassName(nav().asDecl(fClass)), method }), this));
/*      */       }
/*      */     }
/* 1153 */     else if (!fClass.equals(nav().ref(XmlType.DEFAULT.class))) {
/* 1154 */       this.builder.reportError(new IllegalAnnotationException(Messages.FACTORY_CLASS_NEEDS_FACTORY_METHOD.format(new Object[] { nav().getClassName(nav().asDecl(fClass)) }), this));
/*      */     }
/*      */     
/* 1157 */     return this.factoryMethod != null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/* 1162 */   public Method getFactoryMethod() { return (Method)this.factoryMethod; }
/*      */   
/* 1164 */   private static final String[] DEFAULT_ORDER = new String[0];
/*      */   
/*      */   protected void checkFieldXmlLocation(F f) {}
/*      */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\impl\ClassInfoImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */