/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import com.sun.xml.bind.api.AccessorException;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeLeafInfo;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Loader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.TextLoader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.XsiTypeLoader;
/*     */ import java.io.IOException;
/*     */ import javax.xml.bind.helpers.ValidationEventImpl;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class LeafBeanInfoImpl<BeanT>
/*     */   extends JaxBeanInfo<BeanT>
/*     */ {
/*     */   private final Loader loader;
/*     */   private final Loader loaderWithSubst;
/*     */   private final Transducer<BeanT> xducer;
/*     */   private final Name tagName;
/*     */   
/*     */   public LeafBeanInfoImpl(JAXBContextImpl grammar, RuntimeLeafInfo li)
/*     */   {
/*  45 */     super(grammar, li, li.getClazz(), li.getTypeNames(), li.isElement(), true, false);
/*     */     
/*  47 */     this.xducer = li.getTransducer();
/*  48 */     this.loader = new TextLoader(this.xducer);
/*  49 */     this.loaderWithSubst = new XsiTypeLoader(this);
/*     */     
/*  51 */     if (isElement()) {
/*  52 */       this.tagName = grammar.nameBuilder.createElementName(li.getElementName());
/*     */     } else
/*  54 */       this.tagName = null;
/*     */   }
/*     */   
/*     */   public QName getTypeName(BeanT instance) {
/*  58 */     QName tn = this.xducer.getTypeName(instance);
/*  59 */     if (tn != null) { return tn;
/*     */     }
/*  61 */     return super.getTypeName(instance);
/*     */   }
/*     */   
/*     */   public final String getElementNamespaceURI(BeanT _) {
/*  65 */     return this.tagName.nsUri;
/*     */   }
/*     */   
/*     */   public final String getElementLocalName(BeanT _) {
/*  69 */     return this.tagName.localName;
/*     */   }
/*     */   
/*     */   public BeanT createInstance(UnmarshallingContext context) {
/*  73 */     throw new UnsupportedOperationException();
/*     */   }
/*     */   
/*     */   public final boolean reset(BeanT bean, UnmarshallingContext context) {
/*  77 */     return false;
/*     */   }
/*     */   
/*     */   public final String getId(BeanT bean, XMLSerializer target) {
/*  81 */     return null;
/*     */   }
/*     */   
/*     */   public final void serializeBody(BeanT bean, XMLSerializer w)
/*     */     throws SAXException, IOException, XMLStreamException
/*     */   {
/*     */     try
/*     */     {
/*  89 */       this.xducer.writeText(w, bean, null);
/*     */     } catch (AccessorException e) {
/*  91 */       w.reportError(null, e);
/*     */     }
/*     */   }
/*     */   
/*     */   public final void serializeAttributes(BeanT bean, XMLSerializer target) {}
/*     */   
/*     */   public final void serializeRoot(BeanT bean, XMLSerializer target)
/*     */     throws SAXException, IOException, XMLStreamException
/*     */   {
/* 100 */     if (this.tagName == null) {
/* 101 */       target.reportError(new ValidationEventImpl(1, Messages.UNABLE_TO_MARSHAL_NON_ELEMENT.format(new Object[] { bean.getClass().getName() }), null, null));
/*     */ 
/*     */ 
/*     */     }
/*     */     else
/*     */     {
/*     */ 
/*     */ 
/* 109 */       target.startElement(this.tagName, bean);
/* 110 */       target.childAsSoleContent(bean, null);
/* 111 */       target.endElement();
/*     */     }
/*     */   }
/*     */   
/*     */   public final void serializeURIs(BeanT bean, XMLSerializer target)
/*     */     throws SAXException
/*     */   {
/* 118 */     if (this.xducer.useNamespace()) {
/*     */       try {
/* 120 */         this.xducer.declareNamespace(bean, target);
/*     */       } catch (AccessorException e) {
/* 122 */         target.reportError(null, e);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public final Loader getLoader(JAXBContextImpl context, boolean typeSubstitutionCapable) {
/* 128 */     if (typeSubstitutionCapable) {
/* 129 */       return this.loaderWithSubst;
/*     */     }
/* 131 */     return this.loader;
/*     */   }
/*     */   
/*     */   public Transducer<BeanT> getTransducer() {
/* 135 */     return this.xducer;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\LeafBeanInfoImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */