/*     */ package net.rubyeye.xmemcached.utils;
/*     */ 
/*     */ import com.google.code.yanf4j.config.Configuration;
/*     */ import java.io.IOException;
/*     */ import java.net.InetSocketAddress;
/*     */ import java.util.HashMap;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import net.rubyeye.xmemcached.CommandFactory;
/*     */ import net.rubyeye.xmemcached.KeyProvider;
/*     */ import net.rubyeye.xmemcached.MemcachedClient;
/*     */ import net.rubyeye.xmemcached.MemcachedClientBuilder;
/*     */ import net.rubyeye.xmemcached.MemcachedSessionLocator;
/*     */ import net.rubyeye.xmemcached.XMemcachedClientBuilder;
/*     */ import net.rubyeye.xmemcached.auth.AuthInfo;
/*     */ import net.rubyeye.xmemcached.buffer.BufferAllocator;
/*     */ import net.rubyeye.xmemcached.buffer.SimpleBufferAllocator;
/*     */ import net.rubyeye.xmemcached.command.TextCommandFactory;
/*     */ import net.rubyeye.xmemcached.impl.ArrayMemcachedSessionLocator;
/*     */ import net.rubyeye.xmemcached.impl.DefaultKeyProvider;
/*     */ import net.rubyeye.xmemcached.transcoders.SerializingTranscoder;
/*     */ import net.rubyeye.xmemcached.transcoders.Transcoder;
/*     */ import org.springframework.beans.factory.FactoryBean;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class XMemcachedClientFactoryBean
/*     */   implements FactoryBean
/*     */ {
/*  58 */   private MemcachedSessionLocator sessionLocator = new ArrayMemcachedSessionLocator();
/*  59 */   private BufferAllocator bufferAllocator = new SimpleBufferAllocator();
/*     */   private String servers;
/*     */   private List<Integer> weights;
/*  62 */   private Transcoder transcoder = new SerializingTranscoder();
/*     */   
/*  64 */   private Configuration configuration = XMemcachedClientBuilder.getDefaultConfiguration();
/*     */   
/*  66 */   private CommandFactory commandFactory = new TextCommandFactory();
/*     */   
/*  68 */   private Map<InetSocketAddress, AuthInfo> authInfoMap = new HashMap();
/*     */   
/*     */   private String name;
/*     */   
/*  72 */   private int connectionPoolSize = 1;
/*     */   
/*     */   private MemcachedClient memcachedClient;
/*     */   
/*     */   private boolean failureMode;
/*     */   
/*  78 */   private long opTimeout = 5000L;
/*     */   
/*  80 */   private KeyProvider keyProvider = DefaultKeyProvider.INSTANCE;
/*     */   
/*  82 */   private int maxQueuedNoReplyOperations = MemcachedClient.DEFAULT_MAX_QUEUED_NOPS;
/*     */   
/*     */   public long getOpTimeout() {
/*  85 */     return this.opTimeout;
/*     */   }
/*     */   
/*     */   public KeyProvider getKeyProvider() {
/*  89 */     return this.keyProvider;
/*     */   }
/*     */   
/*     */   public void setKeyProvider(KeyProvider keyProvider) {
/*  93 */     this.keyProvider = keyProvider;
/*     */   }
/*     */   
/*     */   public void setOpTimeout(long opTimeout) {
/*  97 */     this.opTimeout = opTimeout;
/*     */   }
/*     */   
/*     */   public final CommandFactory getCommandFactory() {
/* 101 */     return this.commandFactory;
/*     */   }
/*     */   
/*     */   public final void setCommandFactory(CommandFactory commandFactory) {
/* 105 */     this.commandFactory = commandFactory;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public Map<InetSocketAddress, AuthInfo> getAuthInfoMap()
/*     */   {
/* 113 */     return this.authInfoMap;
/*     */   }
/*     */   
/*     */   public void setAuthInfoMap(Map<InetSocketAddress, AuthInfo> authInfoMap) {
/* 117 */     this.authInfoMap = authInfoMap;
/*     */   }
/*     */   
/*     */   public boolean isFailureMode() {
/* 121 */     return this.failureMode;
/*     */   }
/*     */   
/*     */   public void setFailureMode(boolean failureMode) {
/* 125 */     this.failureMode = failureMode;
/*     */   }
/*     */   
/*     */   public String getName() {
/* 129 */     return this.name;
/*     */   }
/*     */   
/*     */   public void setName(String name) {
/* 133 */     this.name = name;
/*     */   }
/*     */   
/*     */   public int getConnectionPoolSize() {
/* 137 */     return this.connectionPoolSize;
/*     */   }
/*     */   
/*     */   public final void setConnectionPoolSize(int poolSize) {
/* 141 */     this.connectionPoolSize = poolSize;
/*     */   }
/*     */   
/*     */   public void setSessionLocator(MemcachedSessionLocator sessionLocator) {
/* 145 */     this.sessionLocator = sessionLocator;
/*     */   }
/*     */   
/*     */   public void setBufferAllocator(BufferAllocator bufferAllocator) {
/* 149 */     this.bufferAllocator = bufferAllocator;
/*     */   }
/*     */   
/*     */   public void setTranscoder(Transcoder transcoder)
/*     */   {
/* 154 */     this.transcoder = transcoder;
/*     */   }
/*     */   
/*     */   public void setConfiguration(Configuration configuration) {
/* 158 */     this.configuration = configuration;
/*     */   }
/*     */   
/*     */   public String getServers() {
/* 162 */     return this.servers;
/*     */   }
/*     */   
/*     */   public void setServers(String servers) {
/* 166 */     this.servers = servers;
/*     */   }
/*     */   
/*     */   public MemcachedSessionLocator getSessionLocator() {
/* 170 */     return this.sessionLocator;
/*     */   }
/*     */   
/*     */   public BufferAllocator getBufferAllocator() {
/* 174 */     return this.bufferAllocator;
/*     */   }
/*     */   
/*     */   public Transcoder getTranscoder()
/*     */   {
/* 179 */     return this.transcoder;
/*     */   }
/*     */   
/*     */   public List<Integer> getWeights() {
/* 183 */     return this.weights;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setMaxQueuedNoReplyOperations(int maxQueuedNoReplyOperations)
/*     */   {
/* 194 */     if (maxQueuedNoReplyOperations <= 1)
/* 195 */       throw new IllegalArgumentException("maxQueuedNoReplyOperations<=1");
/* 196 */     this.maxQueuedNoReplyOperations = maxQueuedNoReplyOperations;
/*     */   }
/*     */   
/*     */   public void setWeights(List<Integer> weights) {
/* 200 */     this.weights = weights;
/*     */   }
/*     */   
/*     */   public Configuration getConfiguration() {
/* 204 */     return this.configuration;
/*     */   }
/*     */   
/*     */   public Object getObject() throws Exception {
/* 208 */     checkAttribute();
/* 209 */     Map<InetSocketAddress, InetSocketAddress> serverMap = getServerMap();
/*     */     
/* 211 */     int[] weightsArray = getWeightsArray(serverMap);
/* 212 */     MemcachedClientBuilder builder = newBuilder(serverMap, weightsArray);
/*     */     
/* 214 */     configBuilder(builder);
/* 215 */     this.memcachedClient = builder.build();
/* 216 */     this.memcachedClient.setOpTimeout(this.opTimeout);
/* 217 */     return this.memcachedClient;
/*     */   }
/*     */   
/*     */   private MemcachedClientBuilder newBuilder(Map<InetSocketAddress, InetSocketAddress> serverMap, int[] weightsArray)
/*     */   {
/*     */     MemcachedClientBuilder builder;
/*     */     MemcachedClientBuilder builder;
/* 224 */     if (weightsArray == null) {
/* 225 */       builder = new XMemcachedClientBuilder(serverMap);
/*     */     } else {
/* 227 */       builder = new XMemcachedClientBuilder(serverMap, weightsArray);
/*     */     }
/* 229 */     return builder;
/*     */   }
/*     */   
/*     */   private void configBuilder(MemcachedClientBuilder builder) {
/* 233 */     builder.setConfiguration(this.configuration);
/* 234 */     builder.setBufferAllocator(this.bufferAllocator);
/* 235 */     builder.setSessionLocator(this.sessionLocator);
/* 236 */     builder.setTranscoder(this.transcoder);
/* 237 */     builder.setCommandFactory(this.commandFactory);
/* 238 */     builder.setConnectionPoolSize(this.connectionPoolSize);
/* 239 */     builder.setAuthInfoMap(this.authInfoMap);
/* 240 */     builder.setFailureMode(this.failureMode);
/* 241 */     builder.setKeyProvider(this.keyProvider);
/* 242 */     builder.setMaxQueuedNoReplyOperations(this.maxQueuedNoReplyOperations);
/* 243 */     builder.setName(this.name);
/*     */   }
/*     */   
/*     */   private int[] getWeightsArray(Map<InetSocketAddress, InetSocketAddress> serverMap)
/*     */   {
/* 248 */     int[] weightsArray = null;
/* 249 */     if ((serverMap != null) && (serverMap.size() > 0) && (this.weights != null)) {
/* 250 */       if (this.weights.size() < serverMap.size()) {
/* 251 */         throw new IllegalArgumentException("Weight list's size is less than server list's size");
/*     */       }
/*     */       
/* 254 */       weightsArray = new int[this.weights.size()];
/* 255 */       for (int i = 0; i < weightsArray.length; i++) {
/* 256 */         weightsArray[i] = ((Integer)this.weights.get(i)).intValue();
/*     */       }
/*     */     }
/* 259 */     return weightsArray;
/*     */   }
/*     */   
/*     */   private Map<InetSocketAddress, InetSocketAddress> getServerMap() {
/* 263 */     Map<InetSocketAddress, InetSocketAddress> serverMap = null;
/*     */     
/* 265 */     if ((this.servers != null) && (this.servers.length() > 0)) {
/* 266 */       serverMap = AddrUtil.getAddressMap(this.servers);
/*     */     }
/*     */     
/* 269 */     return serverMap;
/*     */   }
/*     */   
/*     */   private void checkAttribute() {
/* 273 */     if (this.bufferAllocator == null) {
/* 274 */       throw new NullPointerException("Null BufferAllocator");
/*     */     }
/* 276 */     if (this.sessionLocator == null) {
/* 277 */       throw new NullPointerException("Null MemcachedSessionLocator");
/*     */     }
/* 279 */     if (this.configuration == null) {
/* 280 */       throw new NullPointerException("Null networking configuration");
/*     */     }
/* 282 */     if (this.commandFactory == null) {
/* 283 */       throw new NullPointerException("Null command factory");
/*     */     }
/* 285 */     if ((this.weights != null) && (this.servers == null)) {
/* 286 */       throw new NullPointerException("Empty server list");
/*     */     }
/*     */   }
/*     */   
/*     */   public void shutdown() throws IOException {
/* 291 */     if (this.memcachedClient != null) {
/* 292 */       this.memcachedClient.shutdown();
/*     */     }
/*     */   }
/*     */   
/*     */   public Class getObjectType()
/*     */   {
/* 298 */     return MemcachedClient.class;
/*     */   }
/*     */   
/*     */   public boolean isSingleton() {
/* 302 */     return true;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\utils\XMemcachedClientFactoryBean.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */