/*     */ package org.hibernate.annotations.common.util;
/*     */ 
/*     */ import java.lang.reflect.Field;
/*     */ import java.lang.reflect.Member;
/*     */ import java.lang.reflect.Method;
/*     */ import java.lang.reflect.Modifier;
/*     */ import org.hibernate.annotations.common.AssertionFailure;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class ReflectHelper
/*     */ {
/*  16 */   private static final Class[] OBJECT = { Object.class };
/*     */   private static final Method OBJECT_EQUALS;
/*  18 */   private static final Class[] NO_PARAM = new Class[0];
/*     */   private static final Method OBJECT_HASHCODE;
/*     */   
/*     */   static {
/*     */     Method eq;
/*     */     Method hash;
/*     */     try {
/*  25 */       eq = Object.class.getMethod("equals", OBJECT);
/*  26 */       hash = Object.class.getMethod("hashCode", NO_PARAM);
/*     */     }
/*     */     catch (Exception e) {
/*  29 */       throw new AssertionFailure("Could not find Object.equals() or Object.hashCode()", e);
/*     */     }
/*  31 */     OBJECT_EQUALS = eq;
/*  32 */     OBJECT_HASHCODE = hash;
/*     */   }
/*     */   
/*     */   public static boolean overridesEquals(Class clazz) {
/*     */     Method equals;
/*     */     try {
/*  38 */       equals = clazz.getMethod("equals", OBJECT);
/*     */     }
/*     */     catch (NoSuchMethodException nsme) {
/*  41 */       return false;
/*     */     }
/*  43 */     return !OBJECT_EQUALS.equals(equals);
/*     */   }
/*     */   
/*     */   public static boolean overridesHashCode(Class clazz) {
/*     */     Method hashCode;
/*     */     try {
/*  49 */       hashCode = clazz.getMethod("hashCode", NO_PARAM);
/*     */     }
/*     */     catch (NoSuchMethodException nsme) {
/*  52 */       return false;
/*     */     }
/*  54 */     return !OBJECT_HASHCODE.equals(hashCode);
/*     */   }
/*     */   
/*     */   public static Class classForName(String name) throws ClassNotFoundException {
/*     */     try {
/*  59 */       ClassLoader contextClassLoader = Thread.currentThread().getContextClassLoader();
/*  60 */       if (contextClassLoader != null) {
/*  61 */         return contextClassLoader.loadClass(name);
/*     */       }
/*     */     }
/*     */     catch (Throwable t) {}
/*     */     
/*  66 */     return Class.forName(name);
/*     */   }
/*     */   
/*     */   public static Class classForName(String name, Class caller) throws ClassNotFoundException {
/*     */     try {
/*  71 */       ClassLoader contextClassLoader = Thread.currentThread().getContextClassLoader();
/*  72 */       if (contextClassLoader != null) {
/*  73 */         return contextClassLoader.loadClass(name);
/*     */       }
/*     */     }
/*     */     catch (Throwable e) {}
/*     */     
/*  78 */     return Class.forName(name, true, caller.getClassLoader());
/*     */   }
/*     */   
/*     */   public static boolean isPublic(Class clazz, Member member) {
/*  82 */     return (Modifier.isPublic(member.getModifiers())) && (Modifier.isPublic(clazz.getModifiers()));
/*     */   }
/*     */   
/*     */   public static Object getConstantValue(String name) {
/*     */     Class clazz;
/*     */     try {
/*  88 */       clazz = classForName(StringHelper.qualifier(name));
/*     */     }
/*     */     catch (Throwable t) {
/*  91 */       return null;
/*     */     }
/*     */     try {
/*  94 */       return clazz.getField(StringHelper.unqualify(name)).get(null);
/*     */     }
/*     */     catch (Throwable t) {}
/*  97 */     return null;
/*     */   }
/*     */   
/*     */   public static boolean isAbstractClass(Class clazz)
/*     */   {
/* 102 */     int modifier = clazz.getModifiers();
/* 103 */     return (Modifier.isAbstract(modifier)) || (Modifier.isInterface(modifier));
/*     */   }
/*     */   
/*     */   public static boolean isFinalClass(Class clazz) {
/* 107 */     return Modifier.isFinal(clazz.getModifiers());
/*     */   }
/*     */   
/*     */   public static Method getMethod(Class clazz, Method method) {
/*     */     try {
/* 112 */       return clazz.getMethod(method.getName(), method.getParameterTypes());
/*     */     }
/*     */     catch (Exception e) {}
/* 115 */     return null;
/*     */   }
/*     */ }


/* Location:              /Users/anandkum/Downloads/hibernate-commons-annotations-3.0.0.ga.jar!/org/hibernate/annotations/common/util/ReflectHelper.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */