/*     */ package com.google.code.yanf4j.core.impl;
/*     */ 
/*     */ import com.google.code.yanf4j.buffer.IoBuffer;
/*     */ import com.google.code.yanf4j.core.CodecFactory;
/*     */ import com.google.code.yanf4j.core.CodecFactory.Decoder;
/*     */ import com.google.code.yanf4j.core.CodecFactory.Encoder;
/*     */ import com.google.code.yanf4j.core.Session;
/*     */ import com.google.code.yanf4j.util.ByteBufferMatcher;
/*     */ import com.google.code.yanf4j.util.ShiftAndByteBufferMatcher;
/*     */ import java.nio.ByteBuffer;
/*     */ import java.nio.CharBuffer;
/*     */ import java.nio.charset.Charset;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class TextLineCodecFactory
/*     */   implements CodecFactory
/*     */ {
/*  45 */   public static final IoBuffer SPLIT = IoBuffer.wrap("\r\n".getBytes());
/*     */   
/*  47 */   private static final ByteBufferMatcher SPLIT_PATTERN = new ShiftAndByteBufferMatcher(SPLIT);
/*     */   
/*     */   public static final String DEFAULT_CHARSET_NAME = "utf-8";
/*     */   
/*     */   private Charset charset;
/*     */   
/*     */   public TextLineCodecFactory()
/*     */   {
/*  55 */     this.charset = Charset.forName("utf-8");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*  60 */   public TextLineCodecFactory(String charsetName) { this.charset = Charset.forName(charsetName); }
/*     */   
/*     */   class StringDecoder implements CodecFactory.Decoder {
/*     */     StringDecoder() {}
/*     */     
/*  65 */     public Object decode(IoBuffer buffer, Session session) { String result = null;
/*  66 */       int index = TextLineCodecFactory.SPLIT_PATTERN.matchFirst(buffer);
/*  67 */       if (index >= 0) {
/*  68 */         int limit = buffer.limit();
/*  69 */         buffer.limit(index);
/*  70 */         CharBuffer charBuffer = TextLineCodecFactory.this.charset.decode(buffer.buf());
/*  71 */         result = charBuffer.toString();
/*  72 */         buffer.limit(limit);
/*  73 */         buffer.position(index + TextLineCodecFactory.SPLIT.remaining());
/*     */       }
/*     */       
/*  76 */       return result;
/*     */     }
/*     */   }
/*     */   
/*  80 */   private CodecFactory.Decoder decoder = new StringDecoder();
/*     */   
/*     */ 
/*     */ 
/*  84 */   public CodecFactory.Decoder getDecoder() { return this.decoder; }
/*     */   
/*     */   class StringEncoder implements CodecFactory.Encoder {
/*     */     StringEncoder() {}
/*     */     
/*     */     public IoBuffer encode(Object msg, Session session) {
/*  90 */       if (msg == null) {
/*  91 */         return null;
/*     */       }
/*  93 */       String message = (String)msg;
/*  94 */       ByteBuffer buff = TextLineCodecFactory.this.charset.encode(message);
/*  95 */       IoBuffer resultBuffer = IoBuffer.allocate(buff.remaining() + TextLineCodecFactory.SPLIT.remaining());
/*  96 */       resultBuffer.put(buff);
/*  97 */       resultBuffer.put(TextLineCodecFactory.SPLIT.slice());
/*  98 */       resultBuffer.flip();
/*  99 */       return resultBuffer;
/*     */     }
/*     */   }
/*     */   
/* 103 */   private CodecFactory.Encoder encoder = new StringEncoder();
/*     */   
/*     */   public CodecFactory.Encoder getEncoder()
/*     */   {
/* 107 */     return this.encoder;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\google\code\yanf4j\core\impl\TextLineCodecFactory.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */