/*    */ package com.sun.xml.bind.v2.runtime.reflect;
/*    */ 
/*    */ import com.sun.xml.bind.api.AccessorException;
/*    */ import com.sun.xml.bind.v2.runtime.Coordinator;
/*    */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*    */ import javax.xml.bind.JAXBException;
/*    */ import javax.xml.bind.annotation.adapters.XmlAdapter;
/*    */ import org.xml.sax.SAXException;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ final class AdaptedLister<BeanT, PropT, InMemItemT, OnWireItemT, PackT>
/*    */   extends Lister<BeanT, PropT, OnWireItemT, PackT>
/*    */ {
/*    */   private final Lister<BeanT, PropT, InMemItemT, PackT> core;
/*    */   private final Class<? extends XmlAdapter<OnWireItemT, InMemItemT>> adapter;
/*    */   
/*    */   AdaptedLister(Lister<BeanT, PropT, InMemItemT, PackT> core, Class<? extends XmlAdapter<OnWireItemT, InMemItemT>> adapter)
/*    */   {
/* 23 */     this.core = core;
/* 24 */     this.adapter = adapter;
/*    */   }
/*    */   
/*    */   private XmlAdapter<OnWireItemT, InMemItemT> getAdapter() {
/* 28 */     return Coordinator._getInstance().getAdapter(this.adapter);
/*    */   }
/*    */   
/*    */   public ListIterator<OnWireItemT> iterator(PropT prop, XMLSerializer context) {
/* 32 */     return new ListIteratorImpl(this.core.iterator(prop, context), context);
/*    */   }
/*    */   
/*    */   public PackT startPacking(BeanT bean, Accessor<BeanT, PropT> accessor) throws AccessorException {
/* 36 */     return (PackT)this.core.startPacking(bean, accessor);
/*    */   }
/*    */   
/*    */   public void addToPack(PackT pack, OnWireItemT item) throws AccessorException {
/*    */     InMemItemT r;
/*    */     try {
/* 42 */       r = getAdapter().unmarshal(item);
/*    */     } catch (Exception e) {
/* 44 */       throw new AccessorException(e);
/*    */     }
/* 46 */     this.core.addToPack(pack, r);
/*    */   }
/*    */   
/*    */   public void endPacking(PackT pack, BeanT bean, Accessor<BeanT, PropT> accessor) throws AccessorException {
/* 50 */     this.core.endPacking(pack, bean, accessor);
/*    */   }
/*    */   
/*    */   public void reset(BeanT bean, Accessor<BeanT, PropT> accessor) throws AccessorException {
/* 54 */     this.core.reset(bean, accessor);
/*    */   }
/*    */   
/*    */   private final class ListIteratorImpl implements ListIterator<OnWireItemT> {
/*    */     private final ListIterator<InMemItemT> core;
/*    */     private final XMLSerializer serializer;
/*    */     
/*    */     public ListIteratorImpl(XMLSerializer core) {
/* 62 */       this.core = core;
/* 63 */       this.serializer = serializer;
/*    */     }
/*    */     
/*    */     public boolean hasNext() {
/* 67 */       return this.core.hasNext();
/*    */     }
/*    */     
/*    */     public OnWireItemT next() throws SAXException, JAXBException {
/* 71 */       InMemItemT next = this.core.next();
/*    */       try {
/* 73 */         return (OnWireItemT)AdaptedLister.this.getAdapter().marshal(next);
/*    */       } catch (Exception e) {
/* 75 */         this.serializer.reportError(null, e); }
/* 76 */       return null;
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\AdaptedLister.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */