/*    */ package com.sun.xml.bind.v2.runtime.reflect;
/*    */ 
/*    */ import com.sun.xml.bind.api.AccessorException;
/*    */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*    */ import java.util.Map;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ final class PrimitiveArrayListerFloat<BeanT>
/*    */   extends Lister<BeanT, float[], Float, FloatArrayPack>
/*    */ {
/*    */   static void register()
/*    */   {
/* 19 */     Lister.primitiveArrayListers.put(Float.TYPE, new PrimitiveArrayListerFloat());
/*    */   }
/*    */   
/*    */   public ListIterator<Float> iterator(final float[] objects, XMLSerializer context) {
/* 23 */     new ListIterator() {
/* 24 */       int idx = 0;
/*    */       
/* 26 */       public boolean hasNext() { return this.idx < objects.length; }
/*    */       
/*    */       public Float next()
/*    */       {
/* 30 */         return Float.valueOf(objects[(this.idx++)]);
/*    */       }
/*    */     };
/*    */   }
/*    */   
/*    */   public FloatArrayPack startPacking(BeanT current, Accessor<BeanT, float[]> acc) {
/* 36 */     return new FloatArrayPack();
/*    */   }
/*    */   
/*    */   public void addToPack(FloatArrayPack objects, Float o) {
/* 40 */     objects.add(o);
/*    */   }
/*    */   
/*    */   public void endPacking(FloatArrayPack pack, BeanT bean, Accessor<BeanT, float[]> acc) throws AccessorException {
/* 44 */     acc.set(bean, pack.build());
/*    */   }
/*    */   
/*    */   public void reset(BeanT o, Accessor<BeanT, float[]> acc) throws AccessorException {
/* 48 */     acc.set(o, new float[0]);
/*    */   }
/*    */   
/*    */   static final class FloatArrayPack {
/* 52 */     float[] buf = new float[16];
/*    */     int size;
/*    */     
/*    */     void add(Float b) {
/* 56 */       if (this.buf.length == this.size)
/*    */       {
/* 58 */         float[] nb = new float[this.buf.length * 2];
/* 59 */         System.arraycopy(this.buf, 0, nb, 0, this.buf.length);
/* 60 */         this.buf = nb;
/*    */       }
/* 62 */       this.buf[(this.size++)] = b.floatValue();
/*    */     }
/*    */     
/*    */     float[] build() {
/* 66 */       if (this.buf.length == this.size)
/*    */       {
/* 68 */         return this.buf;
/*    */       }
/* 70 */       float[] r = new float[this.size];
/* 71 */       System.arraycopy(this.buf, 0, r, 0, this.size);
/* 72 */       return r;
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\PrimitiveArrayListerFloat.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */