/*    */ package net.rubyeye.xmemcached.command.binary;
/*    */ 
/*    */ import java.net.InetSocketAddress;
/*    */ import java.nio.ByteBuffer;
/*    */ import java.util.concurrent.CountDownLatch;
/*    */ import net.rubyeye.xmemcached.command.CommandType;
/*    */ import net.rubyeye.xmemcached.command.ServerAddressAware;
/*    */ import net.rubyeye.xmemcached.transcoders.CachedData;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class BinaryVersionCommand
/*    */   extends BaseBinaryCommand
/*    */   implements ServerAddressAware
/*    */ {
/*    */   public InetSocketAddress server;
/*    */   
/*    */   public final InetSocketAddress getServer()
/*    */   {
/* 42 */     return this.server;
/*    */   }
/*    */   
/*    */   public final void setServer(InetSocketAddress server) {
/* 46 */     this.server = server;
/*    */   }
/*    */   
/*    */   public BinaryVersionCommand(CountDownLatch latch, InetSocketAddress server)
/*    */   {
/* 51 */     super("[version]", null, CommandType.VERSION, latch, 0, 0L, latch, false, null);
/*    */     
/* 53 */     this.commandType = CommandType.VERSION;
/* 54 */     this.server = server;
/* 55 */     this.opCode = OpCode.VERSION;
/*    */   }
/*    */   
/*    */ 
/*    */   protected boolean readValue(ByteBuffer buffer, int bodyLength, int keyLength, int extrasLength)
/*    */   {
/* 61 */     int valueLength = bodyLength - keyLength - extrasLength;
/* 62 */     if (buffer.remaining() < valueLength) {
/* 63 */       return false;
/*    */     }
/* 65 */     byte[] bytes = new byte[valueLength];
/* 66 */     buffer.get(bytes);
/* 67 */     setResult(new String(bytes));
/* 68 */     countDownLatch();
/* 69 */     return true;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   protected void fillExtras(CachedData data) {}
/*    */   
/*    */ 
/*    */ 
/*    */   protected void fillValue(CachedData data) {}
/*    */   
/*    */ 
/*    */ 
/*    */   protected byte getExtrasLength()
/*    */   {
/* 84 */     return 0;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   protected void fillKey() {}
/*    */   
/*    */ 
/*    */   protected int getKeyLength()
/*    */   {
/* 94 */     return 0;
/*    */   }
/*    */   
/*    */   protected int getValueLength(CachedData data)
/*    */   {
/* 99 */     return 0;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\binary\BinaryVersionCommand.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */