/*    */ package net.rubyeye.xmemcached.transcoders;
/*    */ 
/*    */ import org.slf4j.Logger;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public final class IntegerTranscoder
/*    */   extends PrimitiveTypeTranscoder<Integer>
/*    */ {
/*    */   public CachedData encode(Integer l)
/*    */   {
/* 14 */     if (this.primitiveAsString) {
/* 15 */       byte[] b = encodeString(l.toString());
/* 16 */       int flags = 0;
/* 17 */       if (b.length > this.compressionThreshold) {
/* 18 */         byte[] compressed = compress(b);
/* 19 */         if (compressed.length < b.length) {
/* 20 */           if (log.isDebugEnabled()) {
/* 21 */             log.debug("Compressed " + l.getClass().getName() + " from " + b.length + " to " + compressed.length);
/*    */           }
/*    */           
/*    */ 
/* 25 */           b = compressed;
/* 26 */           flags |= 0x2;
/*    */         }
/* 28 */         else if (log.isDebugEnabled()) {
/* 29 */           log.debug("Compression increased the size of " + l.getClass().getName() + " from " + b.length + " to " + compressed.length);
/*    */         }
/*    */       }
/*    */       
/*    */ 
/*    */ 
/* 35 */       return new CachedData(flags, b, b.length, -1L);
/*    */     }
/* 37 */     return new CachedData(512, this.tu.encodeInt(l.intValue()));
/*    */   }
/*    */   
/*    */   public Integer decode(CachedData d)
/*    */   {
/* 42 */     if (this.primitiveAsString) {
/* 43 */       byte[] data = d.getData();
/* 44 */       if ((d.getFlag() & 0x2) != 0) {
/* 45 */         data = decompress(d.getData());
/*    */       }
/* 47 */       int flag = d.getFlag();
/* 48 */       if (flag == 0) {
/* 49 */         return Integer.valueOf(decodeString(data));
/*    */       }
/* 51 */       return null;
/*    */     }
/*    */     
/* 54 */     if (512 == d.getFlag()) {
/* 55 */       return Integer.valueOf(this.tu.decodeInt(d.getData()));
/*    */     }
/* 57 */     return null;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public void setPrimitiveAsString(boolean primitiveAsString)
/*    */   {
/* 64 */     this.primitiveAsString = primitiveAsString;
/*    */   }
/*    */   
/*    */   public void setPackZeros(boolean packZeros)
/*    */   {
/* 69 */     this.tu.setPackZeros(packZeros);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\transcoders\IntegerTranscoder.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */