/*     */ package org.apache.avro.io;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.OutputStream;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class DirectBinaryEncoder
/*     */   extends BinaryEncoder
/*     */ {
/*     */   private OutputStream out;
/*  43 */   private final byte[] buf = new byte[12];
/*     */   
/*     */ 
/*     */ 
/*     */   DirectBinaryEncoder(OutputStream out)
/*     */   {
/*  49 */     configure(out);
/*     */   }
/*     */   
/*     */   DirectBinaryEncoder configure(OutputStream out) {
/*  53 */     if (null == out) throw new NullPointerException("OutputStream cannot be null!");
/*  54 */     this.out = out;
/*  55 */     return this;
/*     */   }
/*     */   
/*     */   public void flush() throws IOException
/*     */   {
/*  60 */     this.out.flush();
/*     */   }
/*     */   
/*     */   public void writeBoolean(boolean b) throws IOException
/*     */   {
/*  65 */     this.out.write(b ? 1 : 0);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void writeInt(int n)
/*     */     throws IOException
/*     */   {
/*  73 */     int val = n << 1 ^ n >> 31;
/*  74 */     if ((val & 0xFFFFFF80) == 0) {
/*  75 */       this.out.write(val);
/*  76 */       return; }
/*  77 */     if ((val & 0xC000) == 0) {
/*  78 */       this.out.write(0x80 | val);
/*  79 */       this.out.write(val >>> 7);
/*  80 */       return;
/*     */     }
/*  82 */     int len = BinaryData.encodeInt(n, this.buf, 0);
/*  83 */     this.out.write(this.buf, 0, len);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void writeLong(long n)
/*     */     throws IOException
/*     */   {
/*  91 */     long val = n << 1 ^ n >> 63;
/*  92 */     if ((val & 0xFFFFFFFF80000000) == 0L) {
/*  93 */       int i = (int)val;
/*  94 */       while ((i & 0xFFFFFF80) != 0) {
/*  95 */         this.out.write((byte)((0x80 | i) & 0xFF));
/*  96 */         i >>>= 7;
/*     */       }
/*  98 */       this.out.write((byte)i);
/*  99 */       return;
/*     */     }
/* 101 */     int len = BinaryData.encodeLong(n, this.buf, 0);
/* 102 */     this.out.write(this.buf, 0, len);
/*     */   }
/*     */   
/*     */   public void writeFloat(float f) throws IOException
/*     */   {
/* 107 */     int len = BinaryData.encodeFloat(f, this.buf, 0);
/* 108 */     this.out.write(this.buf, 0, len);
/*     */   }
/*     */   
/*     */   public void writeDouble(double d) throws IOException
/*     */   {
/* 113 */     byte[] buf = new byte[8];
/* 114 */     int len = BinaryData.encodeDouble(d, buf, 0);
/* 115 */     this.out.write(buf, 0, len);
/*     */   }
/*     */   
/*     */   public void writeFixed(byte[] bytes, int start, int len) throws IOException
/*     */   {
/* 120 */     this.out.write(bytes, start, len);
/*     */   }
/*     */   
/*     */   protected void writeZero() throws IOException
/*     */   {
/* 125 */     this.out.write(0);
/*     */   }
/*     */   
/*     */   public int bytesBuffered()
/*     */   {
/* 130 */     return 0;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\apache\avro\io\DirectBinaryEncoder.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */