/*    */ package org.hibernate.annotations.common.reflection.java;
/*    */ 
/*    */ import java.lang.reflect.Array;
/*    */ import java.lang.reflect.GenericArrayType;
/*    */ import java.lang.reflect.Type;
/*    */ import java.util.Collection;
/*    */ import org.hibernate.annotations.common.reflection.XClass;
/*    */ import org.hibernate.annotations.common.reflection.java.generics.TypeEnvironment;
/*    */ import org.hibernate.annotations.common.reflection.java.generics.TypeSwitch;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ class JavaXArrayType
/*    */   extends JavaXType
/*    */ {
/*    */   public JavaXArrayType(Type type, TypeEnvironment context, JavaReflectionManager factory)
/*    */   {
/* 19 */     super(type, context, factory);
/*    */   }
/*    */   
/*    */   public boolean isArray() {
/* 23 */     return true;
/*    */   }
/*    */   
/*    */   public boolean isCollection() {
/* 27 */     return false;
/*    */   }
/*    */   
/*    */   public XClass getElementClass() {
/* 31 */     return toXClass(getElementType());
/*    */   }
/*    */   
/*    */   private Type getElementType()
/*    */   {
/* 36 */     (Type)new TypeSwitch()
/*    */     {
/*    */       public Type caseClass(Class classType) {
/* 39 */         return classType.getComponentType();
/*    */       }
/*    */       
/*    */       public Type caseGenericArrayType(GenericArrayType genericArrayType)
/*    */       {
/* 44 */         return genericArrayType.getGenericComponentType();
/*    */       }
/*    */       
/*    */ 
/*    */ 
/* 49 */       public Type defaultCase(Type t) { throw new IllegalArgumentException(t + " is not an array type"); } }.doSwitch(approximate());
/*    */   }
/*    */   
/*    */ 
/*    */   public XClass getClassOrElementClass()
/*    */   {
/* 55 */     return getElementClass();
/*    */   }
/*    */   
/*    */   public Class<? extends Collection> getCollectionClass() {
/* 59 */     return null;
/*    */   }
/*    */   
/*    */   public XClass getMapKey() {
/* 63 */     return null;
/*    */   }
/*    */   
/*    */   public XClass getType() {
/* 67 */     Type boundType = getElementType();
/* 68 */     if ((boundType instanceof Class)) {
/* 69 */       boundType = arrayTypeOf((Class)boundType);
/*    */     }
/* 71 */     return toXClass(boundType);
/*    */   }
/*    */   
/*    */   private Class<? extends Object> arrayTypeOf(Class componentType) {
/* 75 */     return Array.newInstance(componentType, 0).getClass();
/*    */   }
/*    */ }


/* Location:              /Users/anandkum/Downloads/hibernate-commons-annotations-3.0.0.ga.jar!/org/hibernate/annotations/common/reflection/java/JavaXArrayType.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */