/*    */ package org.hibernate.annotations.common.reflection.java;
/*    */ 
/*    */ import java.lang.reflect.Type;
/*    */ import java.util.Collection;
/*    */ import org.hibernate.annotations.common.reflection.XClass;
/*    */ import org.hibernate.annotations.common.reflection.java.generics.TypeEnvironment;
/*    */ import org.hibernate.annotations.common.reflection.java.generics.TypeUtils;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ abstract class JavaXType
/*    */ {
/*    */   private final TypeEnvironment context;
/*    */   private final JavaReflectionManager factory;
/*    */   private final Type approximatedType;
/*    */   private final Type boundType;
/*    */   
/*    */   protected JavaXType(Type unboundType, TypeEnvironment context, JavaReflectionManager factory)
/*    */   {
/* 25 */     this.context = context;
/* 26 */     this.factory = factory;
/* 27 */     this.boundType = context.bind(unboundType);
/* 28 */     this.approximatedType = factory.toApproximatingEnvironment(context).bind(unboundType);
/*    */   }
/*    */   
/*    */   public abstract boolean isArray();
/*    */   
/*    */   public abstract boolean isCollection();
/*    */   
/*    */   public abstract XClass getElementClass();
/*    */   
/*    */   public abstract XClass getClassOrElementClass();
/*    */   
/*    */   public abstract Class<? extends Collection> getCollectionClass();
/*    */   
/*    */   public abstract XClass getMapKey();
/*    */   
/*    */   public abstract XClass getType();
/*    */   
/*    */   public boolean isResolved() {
/* 46 */     return TypeUtils.isResolved(this.boundType);
/*    */   }
/*    */   
/*    */   protected Type approximate() {
/* 50 */     return this.approximatedType;
/*    */   }
/*    */   
/*    */   protected XClass toXClass(Type type) {
/* 54 */     return this.factory.toXClass(type, this.context);
/*    */   }
/*    */ }


/* Location:              /Users/anandkum/Downloads/hibernate-commons-annotations-3.0.0.ga.jar!/org/hibernate/annotations/common/reflection/java/JavaXType.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */