/*    */ package org.hibernate.annotations.common.reflection.java.generics;
/*    */ 
/*    */ import java.lang.reflect.Array;
/*    */ import java.lang.reflect.GenericArrayType;
/*    */ import java.lang.reflect.ParameterizedType;
/*    */ import java.lang.reflect.Type;
/*    */ import java.util.Arrays;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ class TypeFactory
/*    */ {
/*    */   static ParameterizedType createParameterizedType(final Type rawType, Type[] substTypeArgs, final Type ownerType)
/*    */   {
/* 22 */     new ParameterizedType()
/*    */     {
/*    */       public Type[] getActualTypeArguments() {
/* 25 */         return this.val$substTypeArgs;
/*    */       }
/*    */       
/*    */       public Type getRawType() {
/* 29 */         return rawType;
/*    */       }
/*    */       
/*    */       public Type getOwnerType() {
/* 33 */         return ownerType;
/*    */       }
/*    */       
/*    */       public boolean equals(Object obj)
/*    */       {
/* 38 */         if (!(obj instanceof ParameterizedType)) {
/* 39 */           return false;
/*    */         }
/* 41 */         ParameterizedType other = (ParameterizedType)obj;
/* 42 */         return (Arrays.equals(getActualTypeArguments(), other.getActualTypeArguments())) && (TypeFactory.safeEquals(getRawType(), other.getRawType())) && (TypeFactory.safeEquals(getOwnerType(), other.getOwnerType()));
/*    */       }
/*    */       
/*    */ 
/*    */ 
/*    */ 
/*    */       public int hashCode()
/*    */       {
/* 50 */         return TypeFactory.safeHashCode(getActualTypeArguments()) ^ TypeFactory.safeHashCode(getRawType()) ^ TypeFactory.safeHashCode(getOwnerType());
/*    */       }
/*    */     };
/*    */   }
/*    */   
/*    */ 
/*    */   static Type createArrayType(Type componentType)
/*    */   {
/* 58 */     if ((componentType instanceof Class)) {
/* 59 */       return Array.newInstance((Class)componentType, 0).getClass();
/*    */     }
/* 61 */     return createGenericArrayType(componentType);
/*    */   }
/*    */   
/*    */   private static GenericArrayType createGenericArrayType(Type componentType) {
/* 65 */     new GenericArrayType()
/*    */     {
/*    */       public Type getGenericComponentType() {
/* 68 */         return this.val$componentType;
/*    */       }
/*    */       
/*    */       public boolean equals(Object obj)
/*    */       {
/* 73 */         if (!(obj instanceof GenericArrayType)) {
/* 74 */           return false;
/*    */         }
/* 76 */         GenericArrayType other = (GenericArrayType)obj;
/* 77 */         return TypeFactory.safeEquals(getGenericComponentType(), other.getGenericComponentType());
/*    */       }
/*    */       
/*    */       public int hashCode()
/*    */       {
/* 82 */         return TypeFactory.safeHashCode(getGenericComponentType());
/*    */       }
/*    */     };
/*    */   }
/*    */   
/*    */   private static boolean safeEquals(Type t1, Type t2) {
/* 88 */     if (t1 == null) {
/* 89 */       return t2 == null;
/*    */     }
/* 91 */     return t1.equals(t2);
/*    */   }
/*    */   
/*    */   private static int safeHashCode(Object o) {
/* 95 */     if (o == null) {
/* 96 */       return 1;
/*    */     }
/* 98 */     return o.hashCode();
/*    */   }
/*    */ }


/* Location:              /Users/anandkum/Downloads/hibernate-commons-annotations-3.0.0.ga.jar!/org/hibernate/annotations/common/reflection/java/generics/TypeFactory.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */