/*    */ package org.hibernate.annotations.common.reflection.java.generics;
/*    */ 
/*    */ import java.lang.reflect.GenericArrayType;
/*    */ import java.lang.reflect.ParameterizedType;
/*    */ import java.lang.reflect.Type;
/*    */ import java.lang.reflect.TypeVariable;
/*    */ import java.lang.reflect.WildcardType;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class TypeSwitch<T>
/*    */ {
/*    */   public final T doSwitch(Type type)
/*    */   {
/* 18 */     if ((type instanceof Class)) {
/* 19 */       return (T)caseClass((Class)type);
/*    */     }
/* 21 */     if ((type instanceof GenericArrayType)) {
/* 22 */       return (T)caseGenericArrayType((GenericArrayType)type);
/*    */     }
/* 24 */     if ((type instanceof ParameterizedType)) {
/* 25 */       return (T)caseParameterizedType((ParameterizedType)type);
/*    */     }
/* 27 */     if ((type instanceof TypeVariable)) {
/* 28 */       return (T)caseTypeVariable((TypeVariable)type);
/*    */     }
/* 30 */     if ((type instanceof WildcardType)) {
/* 31 */       return (T)caseWildcardType((WildcardType)type);
/*    */     }
/* 33 */     return (T)defaultCase(type);
/*    */   }
/*    */   
/*    */   public T caseWildcardType(WildcardType wildcardType) {
/* 37 */     return (T)defaultCase(wildcardType);
/*    */   }
/*    */   
/*    */   public T caseTypeVariable(TypeVariable typeVariable) {
/* 41 */     return (T)defaultCase(typeVariable);
/*    */   }
/*    */   
/*    */   public T caseClass(Class classType) {
/* 45 */     return (T)defaultCase(classType);
/*    */   }
/*    */   
/*    */   public T caseGenericArrayType(GenericArrayType genericArrayType) {
/* 49 */     return (T)defaultCase(genericArrayType);
/*    */   }
/*    */   
/*    */   public T caseParameterizedType(ParameterizedType parameterizedType) {
/* 53 */     return (T)defaultCase(parameterizedType);
/*    */   }
/*    */   
/*    */   public T defaultCase(Type t) {
/* 57 */     return null;
/*    */   }
/*    */ }


/* Location:              /Users/anandkum/Downloads/hibernate-commons-annotations-3.0.0.ga.jar!/org/hibernate/annotations/common/reflection/java/generics/TypeSwitch.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */