package prefuse.data.expression;

public abstract class BinaryExpression
  extends AbstractExpression
{
  protected int m_op;
  protected Expression m_left;
  protected Expression m_right;
  
  protected BinaryExpression(int paramInt1, int paramInt2, int paramInt3, Expression paramExpression1, Expression paramExpression2)
  {
    if ((paramInt1 < paramInt2) || (paramInt1 > paramInt3)) {
      throw new IllegalArgumentException("Unknown operation type: " + paramInt1);
    }
    if ((paramExpression1 == null) || (paramExpression2 == null)) {
      throw new IllegalArgumentException("Expressions must be non-null.");
    }
    this.m_op = paramInt1;
    this.m_left = paramExpression1;
    this.m_right = paramExpression2;
  }
  
  public Expression getLeftExpression()
  {
    return this.m_left;
  }
  
  public Expression getRightExpression()
  {
    return this.m_right;
  }
  
  public void setLeftExpression(Expression paramExpression)
  {
    this.m_left.removeExpressionListener(this);
    this.m_left = paramExpression;
    if (hasListeners()) {
      paramExpression.addExpressionListener(this);
    }
    fireExpressionChange();
  }
  
  public void setRightExpression(Expression paramExpression)
  {
    this.m_right.removeExpressionListener(this);
    this.m_right = paramExpression;
    if (hasListeners()) {
      paramExpression.addExpressionListener(this);
    }
    fireExpressionChange();
  }
  
  public int getOperation()
  {
    return this.m_op;
  }
  
  public void visit(ExpressionVisitor paramExpressionVisitor)
  {
    paramExpressionVisitor.visitExpression(this);
    paramExpressionVisitor.down();
    this.m_left.visit(paramExpressionVisitor);
    paramExpressionVisitor.up();
    paramExpressionVisitor.down();
    this.m_right.visit(paramExpressionVisitor);
    paramExpressionVisitor.up();
  }
  
  protected void addChildListeners()
  {
    this.m_left.addExpressionListener(this);
    this.m_right.addExpressionListener(this);
  }
  
  protected void removeChildListeners()
  {
    this.m_left.removeExpressionListener(this);
    this.m_right.removeExpressionListener(this);
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\expression\BinaryExpression.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */