package prefuse.data.parser;

import java.sql.Time;
import java.text.DateFormat;
import java.text.ParsePosition;
import java.util.Date;

public class TimeParser
  extends DateParser
{
  protected DateFormat m_dfmt;
  protected ParsePosition m_pos;
  
  public TimeParser()
  {
    this(DateFormat.getTimeInstance(3));
  }
  
  public TimeParser(DateFormat paramDateFormat)
  {
    this.m_dfmt = paramDateFormat;
    this.m_pos = new ParsePosition(0);
  }
  
  public Class getType()
  {
    return Time.class;
  }
  
  public boolean canParse(String paramString)
  {
    try
    {
      parseTime(paramString);
      return true;
    }
    catch (DataParseException localDataParseException) {}
    return false;
  }
  
  public Object parse(String paramString)
    throws DataParseException
  {
    return parseTime(paramString);
  }
  
  public Time parseTime(String paramString)
    throws DataParseException
  {
    this.m_pos.setErrorIndex(0);
    this.m_pos.setIndex(0);
    Time localTime = null;
    try
    {
      localTime = Time.valueOf(paramString);
      this.m_pos.setIndex(paramString.length());
    }
    catch (IllegalArgumentException localIllegalArgumentException)
    {
      localTime = null;
    }
    if (localTime == null)
    {
      Date localDate = this.m_dfmt.parse(paramString, this.m_pos);
      if (localDate != null) {
        localTime = new Time(localDate.getTime());
      }
    }
    if ((localTime == null) || (this.m_pos.getIndex() < paramString.length())) {
      throw new DataParseException("Could not parse Date: " + paramString);
    }
    return localTime;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\parser\TimeParser.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */